import "Turbine"
import "Turbine.UI"
import "Turbine.UI.Lotro"
import "Turbine.Gameplay"

function AddCallback(object, event, callback)
    if (object == nil) then
      return nil
    end
    
    if (object[event] == nil) then
        object[event] = callback;
    else
        if (type(object[event]) == "table") then
            table.insert(object[event], callback);
        else
            object[event] = {object[event], callback};
        end
    end
    return callback;
end

function RemoveCallback(object, event, callback)
    if (object[event] == callback) then
        object[event] = nil;
    else
        if (type(object[event]) == "table") then
            local size = table.getn(object[event]);
            for i = 1, size do
                if (object[event][i] == callback) then
                    table.remove(object[event], i);
                    break;
                end
            end
        end
    end
end

-- Enum?
ResetPolicy = {}
ResetPolicy.Timeout = 1
ResetPolicy.Continuous = 2
ResetPolicy.Hide = 3

-- ******************************************* InitialPluginData ********************************************
GetInitialBuildTable = function()
return 
{
	["Example 3"] = 
	{
		["Shown"] = true,
		["XPos"] = 638.000000,
		["QuickSlotData"] = 
		{
			[1.000000] = "/tell Yourimaginaryfriend You can also unequip gear via the /buildswapper unequip [slotname] command",
			[2.000000] = "/buildswapper unequip legs",
			[4.000000] = "/tell Yourimaginaryfriend if you have any questions, suggestions, or bugs please let me know!  Enjoy!",
			[8.000000] = "",
			[16.000000] = "",
			[17.000000] = "",
			[9.000000] = "",
			[18.000000] = "",
			[5.000000] = "",
			[10.000000] = "",
			[20.000000] = "",
			[30.000000] = "",
			[21.000000] = "",
			[11.000000] = "",
			[22.000000] = "",
			[3.000000] = "/tell Yourimaginaryfriend like that! (you're not wearing any pants)",
			[6.000000] = "",
			[12.000000] = "",
			[24.000000] = "",
			[19.000000] = "",
			[25.000000] = "",
			[13.000000] = "",
			[26.000000] = "",
			[27.000000] = "",
			[7.000000] = "",
			[14.000000] = "",
			[28.000000] = "",
			[23.000000] = "",
			[29.000000] = "",
			[15.000000] = ""
		},
		["Group"] = "PvE",
		["QuickSlotType"] = 
		{
			[1.000000] = 4.000000,
			[2.000000] = 4.000000,
			[4.000000] = 4.000000,
			[8.000000] = 0.000000,
			[16.000000] = 0.000000,
			[17.000000] = 0.000000,
			[9.000000] = 0.000000,
			[18.000000] = 0.000000,
			[5.000000] = 0.000000,
			[10.000000] = 0.000000,
			[20.000000] = 0.000000,
			[30.000000] = 0.000000,
			[21.000000] = 0.000000,
			[11.000000] = 0.000000,
			[22.000000] = 0.000000,
			[3.000000] = 4.000000,
			[6.000000] = 0.000000,
			[12.000000] = 0.000000,
			[24.000000] = 0.000000,
			[19.000000] = 0.000000,
			[25.000000] = 0.000000,
			[13.000000] = 0.000000,
			[26.000000] = 0.000000,
			[27.000000] = 0.000000,
			[7.000000] = 0.000000,
			[14.000000] = 0.000000,
			[28.000000] = 0.000000,
			[23.000000] = 0.000000,
			[29.000000] = 0.000000,
			[15.000000] = 0.000000
		},
		["YPos"] = 33.000000,
		["ResetPolicy"] = 1.000000
	},
	["Example 2"] = 
	{
		["Shown"] = true,
		["XPos"] = 588.000000,
		["QuickSlotData"] = 
		{
			[1.000000] = "/tell Yourimaginaryfriend When you've made a quickslot sequence, you can assign it to different groups in the main menu (via drag and drop)",
			[2.000000] = "/tell Yourimaginaryfriend I personally find this handy as I have conflicting PvP and PvE only sequences and builds, as well as some that apply to both, and you can quickly Hide All or Show All by selecting the group.",
			[4.000000] = "/tell Yourimaginaryfriend You can also just spawn single quickslots via the button at the bottom of the main menu (move them with Ctrl+\\)",
			[8.000000] = "",
			[16.000000] = "",
			[17.000000] = "",
			[9.000000] = "",
			[18.000000] = "",
			[5.000000] = "",
			[10.000000] = "",
			[20.000000] = "",
			[30.000000] = "",
			[21.000000] = "",
			[11.000000] = "",
			[22.000000] = "",
			[3.000000] = "",
			[6.000000] = "",
			[12.000000] = "",
			[24.000000] = "",
			[19.000000] = "",
			[25.000000] = "",
			[13.000000] = "",
			[26.000000] = "",
			[27.000000] = "",
			[7.000000] = "",
			[14.000000] = "",
			[28.000000] = "",
			[23.000000] = "",
			[29.000000] = "",
			[15.000000] = ""
		},
		["Group"] = "PvP",
		["QuickSlotType"] = 
		{
			[1.000000] = 4.000000,
			[2.000000] = 4.000000,
			[4.000000] = 4.000000,
			[8.000000] = 0.000000,
			[16.000000] = 0.000000,
			[17.000000] = 0.000000,
			[9.000000] = 0.000000,
			[18.000000] = 0.000000,
			[5.000000] = 0.000000,
			[10.000000] = 0.000000,
			[20.000000] = 0.000000,
			[30.000000] = 0.000000,
			[21.000000] = 0.000000,
			[11.000000] = 0.000000,
			[22.000000] = 0.000000,
			[3.000000] = 0.000000,
			[6.000000] = 0.000000,
			[12.000000] = 0.000000,
			[24.000000] = 0.000000,
			[19.000000] = 0.000000,
			[25.000000] = 0.000000,
			[13.000000] = 0.000000,
			[26.000000] = 0.000000,
			[27.000000] = 0.000000,
			[7.000000] = 0.000000,
			[14.000000] = 0.000000,
			[28.000000] = 0.000000,
			[23.000000] = 0.000000,
			[29.000000] = 0.000000,
			[15.000000] = 0.000000
		},
		["YPos"] = 32.000000,
		["ResetPolicy"] = 1.000000
	},
	["Example1"] = 
	{
		["Shown"] = true,
		["XPos"] = 537.000000,
		["QuickSlotData"] = 
		{
			[1.000000] = "/tell YourImaginaryFriend So when you click this",
			[2.000000] = "/tell YourImaginaryFriend it will cycle to the next quickslot",
			[4.000000] = "/tell YourImaginaryFriend The reset policies determine what happens when you get to the end of the sequence.",
			[8.000000] = "",
			[16.000000] = "",
			[17.000000] = "",
			[9.000000] = "",
			[18.000000] = "",
			[5.000000] = "/tell YourImaginaryFriend Timeout causes it to dissappear for 2 seconds, Continuous will automatically restart at the beginning, and Hide will just plain Hide it when you're done",
			[10.000000] = "",
			[20.000000] = "",
			[30.000000] = "",
			[21.000000] = "",
			[11.000000] = "",
			[22.000000] = "",
			[3.000000] = "/tell YourImaginaryFriend so you can spam click one quickslot and perform a bunch of different actions",
			[6.000000] = "/tell YourImaginaryFriend When you close the Main Menu, you can reopen it again by either",
			[12.000000] = "",
			[24.000000] = "",
			[19.000000] = "",
			[25.000000] = "",
			[13.000000] = "",
			[26.000000] = "",
			[27.000000] = "",
			[7.000000] = "/tell YourImaginaryFriend clicking on the helm icon at the top of your screen (move it where you like) or typing /buildswapper toggle",
			[14.000000] = "",
			[28.000000] = "",
			[23.000000] = "",
			[29.000000] = "",
			[15.000000] = ""
		},
		["Group"] = "General",
		["QuickSlotType"] = 
		{
			[1.000000] = 4.000000,
			[2.000000] = 4.000000,
			[4.000000] = 4.000000,
			[8.000000] = 0.000000,
			[16.000000] = 0.000000,
			[17.000000] = 0.000000,
			[9.000000] = 0.000000,
			[18.000000] = 0.000000,
			[5.000000] = 4.000000,
			[10.000000] = 0.000000,
			[20.000000] = 0.000000,
			[30.000000] = 0.000000,
			[21.000000] = 0.000000,
			[11.000000] = 0.000000,
			[22.000000] = 0.000000,
			[3.000000] = 4.000000,
			[6.000000] = 4.000000,
			[12.000000] = 0.000000,
			[24.000000] = 0.000000,
			[19.000000] = 0.000000,
			[25.000000] = 0.000000,
			[13.000000] = 0.000000,
			[26.000000] = 0.000000,
			[27.000000] = 0.000000,
			[7.000000] = 4.000000,
			[14.000000] = 0.000000,
			[28.000000] = 0.000000,
			[23.000000] = 0.000000,
			[29.000000] = 0.000000,
			[15.000000] = 0.000000
		},
		["YPos"] = 33.000000,
		["ResetPolicy"] = 1.000000
	},
	["Get Nude"] = 
	{
		["Shown"] = true,
		["XPos"] = 696.000000,
		["QuickSlotData"] = 
		{
			[1.000000] = "/buildswapper unequip legs",
			[2.000000] = "/buildswapper unequip chest",
			[4.000000] = "/buildswapper unequip boots",
			[8.000000] = "",
			[16.000000] = "",
			[17.000000] = "",
			[9.000000] = "",
			[18.000000] = "",
			[5.000000] = "/buildswapper unequip shoulder",
			[10.000000] = "",
			[20.000000] = "",
			[30.000000] = "",
			[21.000000] = "",
			[11.000000] = "",
			[22.000000] = "",
			[3.000000] = "/buildswapper unequip helm",
			[6.000000] = "/buildswapper unequip gloves",
			[12.000000] = "",
			[24.000000] = "",
			[19.000000] = "",
			[25.000000] = "",
			[13.000000] = "",
			[26.000000] = "",
			[27.000000] = "",
			[7.000000] = "",
			[14.000000] = "",
			[28.000000] = "",
			[23.000000] = "",
			[29.000000] = "",
			[15.000000] = ""
		},
		["Group"] = "General",
		["QuickSlotType"] = 
		{
			[1.000000] = 4.000000,
			[2.000000] = 4.000000,
			[4.000000] = 4.000000,
			[8.000000] = 0.000000,
			[16.000000] = 0.000000,
			[17.000000] = 0.000000,
			[9.000000] = 0.000000,
			[18.000000] = 0.000000,
			[5.000000] = 4.000000,
			[10.000000] = 0.000000,
			[20.000000] = 0.000000,
			[30.000000] = 0.000000,
			[21.000000] = 0.000000,
			[11.000000] = 0.000000,
			[22.000000] = 0.000000,
			[3.000000] = 4.000000,
			[6.000000] = 4.000000,
			[12.000000] = 0.000000,
			[24.000000] = 0.000000,
			[19.000000] = 0.000000,
			[25.000000] = 0.000000,
			[13.000000] = 0.000000,
			[26.000000] = 0.000000,
			[27.000000] = 0.000000,
			[7.000000] = 0.000000,
			[14.000000] = 0.000000,
			[28.000000] = 0.000000,
			[23.000000] = 0.000000,
			[29.000000] = 0.000000,
			[15.000000] = 0.000000
		},
		["YPos"] = 31.000000,
		["ResetPolicy"] = 1.000000
	}
}
end

GetInitialBuildSwapperGroupsSaveData = function()
return 
{
	["EZToggleLoc"] = 
	{
		["y"] = 21.000000,
		["x"] = 1149.000000
	},
	["GroupList"] = 
	{
		["PvP"] = true,
		["General"] = true,
		["PvE"] = true
	}
}
end



-- **********************************************************************************************************

-- The Gist of Saving is:
--
-- X              define the unload function
-- X              instantiate the main object
-- X              call Load and assign local vars
-- X              set .loaded = false and setwantsupdates(false)
-- X              define the object.Update function in which if the
--                   window isn't loaded yet, define the plugins["pluginname"].unload
--                   function and object:SetWantsUpdates(false)
-- X              add SetWantsUpdates(true) to bottom

OldDataHandled = false;

Controller = {}
Controller.UIEditMode = false;
SequenceWindows = {}
QuickslotsTable = {}
GroupList = {}
EZToggleX = Turbine.UI.Display.GetWidth()/2
EZToggleY = 0

Controller.UnloadData = function()
  BuildSwapMenu:SetWantsUpdates(false)
  SequenceBuilder:SetWantsUpdates(false)
  for i,j in pairs(SequenceWindows) do
    j:SetWantsUpdates(false)
  end
  for i,j in pairs(BuildSwapMenu.MenuItems) do
    j:SetWantsUpdates(false)
  end
  if(not(BuildSwapMenu.SpawnWindow == nil)) then
    BuildSwapMenu.SpawnWindow:SetWantsUpdates(false)
  end

  Turbine.PluginData.Save(Turbine.DataScope.Character, "BuildSwapper", BuildTable);
  
  local temp = {}
  
  for i, value in pairs(QuickslotsTable) do
    temp[i] = {}
    temp[i].xPos = value:GetLeft();
    temp[i].yPos = value:GetTop();
    temp[i].data = value.Quickslot:GetShortcut():GetData();
    temp[i].type = value.Quickslot:GetShortcut():GetType();
  end
  Turbine.PluginData.Save(Turbine.DataScope.Character, "ExtraSlots", temp);
  
  local temp2 = {}
  temp2["EZToggleLoc"] = {}
  temp2["EZToggleLoc"].x = EZToggleWindow:GetLeft();
  temp2["EZToggleLoc"].y = EZToggleWindow:GetTop();
  temp2["GroupList"] = GroupList
  Turbine.PluginData.Save(Turbine.DataScope.Character, "BuildSwapperGroups", temp2);
  
  --Turbine.Shell.RemoveCommand(Controller.ShellCommand);
end

--********************************** DATA *************************************


-- BuildTable[].ShortcutType = {}
-- BuildTable[].ShortcutData = {}
-- BuildTable[].Shown = bool
-- BuildTable[].ResetPolicy = enum
-- BuildTable[].XPos = int
-- BuildTable[].YPos = int
-- BuildTable[].Group

BuildTable = Turbine.PluginData.Load(Turbine.DataScope.Character, "BuildSwapper");
-- Necessary? Idk
if BuildTable == nil then
  BuildTable = GetInitialBuildTable()
end

BuildSwapperGroupsSaveData = Turbine.PluginData.Load(Turbine.DataScope.Character, "BuildSwapperGroups");
if BuildSwapperGroupsSaveData == nil then
  BuildSwapperGroupsSaveData = GetInitialBuildSwapperGroupsSaveData()
  --GroupList["General"] = true;
  --GroupList["PvE"] = true;
  --GroupList["PvP"] = true;
  GroupList = BuildSwapperGroupsSaveData["GroupList"]
else
  GroupList = BuildSwapperGroupsSaveData["GroupList"]
  
  EZToggleX = BuildSwapperGroupsSaveData["EZToggleLoc"].x
  EZToggleY = BuildSwapperGroupsSaveData["EZToggleLoc"].y
end

-- ************************* EZToggleMenu *****************************************************

EZToggleWindow = Turbine.UI.Window()
EZToggleWindow:SetSize(30, 36)
EZToggleWindow:SetBackground("Turwe\\BuildSwapper\\helm.tga");
EZToggleWindow:SetPosition(EZToggleX, EZToggleY);
EZToggleWindow:SetOpacity(.5);
EZToggleWindow:SetZOrder(1000);
EZToggleWindow:SetVisible(true);
EZToggleWindow.MouseDownOnMe = false;
EZToggleWindow.xOffset = 0;
EZToggleWindow.yOffset = 0;

EZToggleWindow.MouseEnter = function()
  EZToggleWindow:SetOpacity(1);
end

EZToggleWindow.MouseLeave = function()  
  EZToggleWindow.ToolTip.Hide();
  EZToggleWindow:SetOpacity(.5);
end

EZToggleWindow.MouseMove = function()
  if EZToggleWindow.MouseDownOnMe then
    local curX, curY = EZToggleWindow:GetPosition();
    local newXOffset, newYOffset = EZToggleWindow:GetMousePosition()
    EZToggleWindow:SetPosition(curX + newXOffset - EZToggleWindow.xOffset, curY + newYOffset - EZToggleWindow.yOffset)
  end
end

EZToggleWindow.MouseDown = function(sender, args)
  EZToggleWindow.ToolTip.Hide();
  if(not(args == nil)) then
    if(not(args["Button"] == nil)) then
      if(args["Button"] == 1) then
        EZToggleWindow.xOffset, EZToggleWindow.yOffset = EZToggleWindow:GetMousePosition();
        EZToggleWindow.MouseDownOnMe = true
      end
    end
  end
end

EZToggleWindow.MouseUp = function()
  EZToggleWindow.MouseDownOnMe = false
end

EZToggleWindow.MouseClick = function(sender, args)
  local curX, curY = EZToggleWindow:GetPosition()
  if((not(curX == EZToggleX)) or (not(curY == EZToggleY))) then -- It moved, so don't treat this as a MouseClick
    EZToggleX = curX
    EZToggleY = curY
    do return end
  end
  
  if(not(args == nil)) then
    if(not(args["Button"] == nil)) then
      if(args["Button"] == 1) then
        if (not SequenceBuilder:IsVisible()) then
          if (not BuildSwapMenu:IsVisible()) then
            BuildSwapMenu.Open()
          else
            BuildSwapMenu:Close()
          end
        end
      elseif(args["Button"] == 2) then
        for a,b in pairs(SequenceWindows) do
          b.Reset()
        end
      end
    end
  end
end

EZToggleWindow.MouseHover = function()
  EZToggleWindow.ToolTip.Show();
end

EZToggleWindow.ToolTip = Turbine.UI.Window()
EZToggleWindow.ToolTip:SetSize(180,50)
EZToggleWindow.ToolTip:SetPosition(0,0)
EZToggleWindow.ToolTip:SetZOrder(EZToggleWindow:GetZOrder() + 1)

EZToggleWindow.ToolTip.Label = Turbine.UI.Label()
EZToggleWindow.ToolTip.Label:SetParent(EZToggleWindow.ToolTip)
EZToggleWindow.ToolTip.Label:SetSize(EZToggleWindow.ToolTip:GetWidth(), EZToggleWindow.ToolTip:GetHeight())
EZToggleWindow.ToolTip.Label:SetBackColor( Turbine.UI.Color(0,0,0) )
EZToggleWindow.ToolTip.Label:SetFont(Turbine.UI.Lotro.Font.Verdana12);
EZToggleWindow.ToolTip.Label:SetText("Left Click for BuildSwapper Menu\nLeft-Click and drag to move\nRight-Click to reset all Quickslot Sequences")

EZToggleWindow.ToolTip.Show = function()
  local parentX, parentY = EZToggleWindow:GetPosition();
  local xPos = EZToggleWindow:GetLeft()
  local yPos = EZToggleWindow:GetTop()
  
  if(parentX < (Turbine.UI.Display:GetWidth()/2)) then -- Display on Right
    xPos =  xPos + EZToggleWindow:GetWidth();
  else -- Display on Left
    xPos = xPos - EZToggleWindow.ToolTip:GetWidth();
  end
  
  if(parentY < (Turbine.UI.Display:GetHeight()/2)) then -- Display on Bottom
    yPos = yPos + EZToggleWindow:GetHeight();
  else -- Display on Top
    yPos = yPos - EZToggleWindow.ToolTip:GetHeight();
  end
  
  EZToggleWindow.ToolTip:SetPosition(xPos, yPos);
  EZToggleWindow.ToolTip:SetVisible(true);
end

EZToggleWindow.ToolTip.Hide = function()
  EZToggleWindow.ToolTip:SetVisible(false);
end

-- ************************* Build Swap Menu **************************************************

BuildSwapMenu = Turbine.UI.Lotro.Window();

-- Attach saving to the BuildSwapMenu
-- I doubt that SetWantsUpdates can be called with just a table? (Controller)... actually, it probably can, try this later
BuildSwapMenu.loaded=false;
BuildSwapMenu:SetWantsUpdates(false);

BuildSwapMenu.Update=function()
  if not BuildSwapMenu.loaded then
    BuildSwapMenu.loaded=true;
    Plugins["BuildSwapper"].Unload = function(self,sender,args)
      Controller.UnloadData();
    end
    if(BuildSwapMenu:IsVisible()) then
      BuildSwapMenu.Time = Turbine.Engine.GetGameTime()
    else
      BuildSwapMenu:SetWantsUpdates(false);
    end
    
    
    BuildSwapMenu.Update = function()
      timeDiff = Turbine.Engine.GetGameTime() - BuildSwapMenu.Time
      if(timeDiff >= 2) then
        BuildSwapMenu.Time = BuildSwapMenu.Time + 2;
        timeDiff = timeDiff - 2;
      end
      
      for k,controlRef in pairs(BuildSwapMenu.PulseList) do
        if(timeDiff > 1) then
          controlRef:SetOpacity(.5 + ((timeDiff - 1)/2));
        else
          controlRef:SetOpacity(1 - (timeDiff/2));
        end
      end
    end
  end
end

BuildSwapMenu.Open = function()
  BuildSwapMenu:SetVisible(true)
  BuildSwapMenu.Time = Turbine.Engine.GetGameTime()
  BuildSwapMenu:SetWantsUpdates(true);
end

BuildSwapMenu.Closing = function()
  for i,j in pairs(BuildSwapMenu.PulseList) do
    j:SetOpacity(1)
  end
  Turbine.PluginData.Save(Turbine.DataScope.Character, "BuildSwapper", BuildTable);
  BuildSwapMenu:SetWantsUpdates(false);
end

BuildSwapMenu:SetPosition( 600, 200 );
BuildSwapMenu:SetSize( 400, 430 );
BuildSwapMenu:SetText( "Build Swapper" );
BuildSwapMenu:SetWantsKeyEvents(true);

BuildSwapMenu.InstructionLabel = Turbine.UI.Label();
BuildSwapMenu.InstructionLabel:SetParent(BuildSwapMenu);
BuildSwapMenu.InstructionLabel:SetPosition(30, 40);
BuildSwapMenu.InstructionLabel:SetSize( 340, 30 );
BuildSwapMenu.InstructionLabel:SetText("Pick a quickslot sequence to edit:");
--BuildSwapMenu.InstructionLabel:SetForeColor( Turbine.UI.Color( 0, 0, 0 ) );
BuildSwapMenu.InstructionLabel:SetOutlineColor( Turbine.UI.Color( .1, .1, .1 ) );
BuildSwapMenu.InstructionLabel:SetFontStyle( Turbine.UI.FontStyle.Outline );
BuildSwapMenu.InstructionLabel:SetFont(Turbine.UI.Lotro.Font.Verdana16);
BuildSwapMenu.InstructionLabel:SetForeColor( Turbine.UI.Color( 1, 1, 1) );

BuildSwapMenu.ListBox = Turbine.UI.ListBox();
BuildSwapMenu.ListBox:SetParent( BuildSwapMenu );
--BuildSwapMenu.ListBox:SetBackColor( Turbine.UI.Color( 0.05, 0.05, 0.05 ) );
BuildSwapMenu.ListBox:SetPosition( 30, 70 );
BuildSwapMenu.ListBox:SetSize( 340, 260 );
BuildSwapMenu.ListBox:SetOrientation( Turbine.UI.Orientation.Vertical );


BuildSwapMenu.ListBox.VScroll = Turbine.UI.Lotro.ScrollBar();
BuildSwapMenu.ListBox.VScroll:SetParent(BuildSwapMenu);
BuildSwapMenu.ListBox.VScroll:SetOrientation(Turbine.UI.Orientation.Vertical);
BuildSwapMenu.ListBox.VScroll:SetPosition(BuildSwapMenu.ListBox:GetLeft()+BuildSwapMenu.ListBox:GetWidth(),BuildSwapMenu.ListBox:GetTop());
BuildSwapMenu.ListBox.VScroll:SetSize(12,BuildSwapMenu.ListBox:GetHeight());
BuildSwapMenu.ListBox.VScroll:SetBackColor(Turbine.UI.Color(.1,.1,.2));
BuildSwapMenu.ListBox:SetVerticalScrollBar(BuildSwapMenu.ListBox.VScroll);

BuildSwapMenu.NewGroupButton = Turbine.UI.Label();
--BuildSwapMenu.NewGroupButton:SetParent( BuildSwapMenu.GroupWindows[newGroupName] );
BuildSwapMenu.NewGroupButton:SetText( "Click to Add a New Category");
BuildSwapMenu.NewGroupButton:SetSize( 340, 30 );
BuildSwapMenu.NewGroupButton:SetOutlineColor( Turbine.UI.Color( 0, 0, 0 ) );
BuildSwapMenu.NewGroupButton:SetFontStyle( Turbine.UI.FontStyle.Outline );
BuildSwapMenu.NewGroupButton:SetFont(Turbine.UI.Lotro.Font.Verdana18);
BuildSwapMenu.NewGroupButton:SetTextAlignment( Turbine.UI.ContentAlignment.BottomCenter );
BuildSwapMenu.ListBox:AddItem(BuildSwapMenu.NewGroupButton);
BuildSwapMenu.NewGroupButton:SetBackground("Turwe\\BuildSwapper\\MenuGroupBar.tga");
BuildSwapMenu.NewGroupButton:SetOpacity(.8);

BuildSwapMenu.ShowCheckBox = Turbine.UI.Lotro.CheckBox();
BuildSwapMenu.ShowCheckBox:SetParent(BuildSwapMenu);
BuildSwapMenu.ShowCheckBox:SetSize(100,25);
BuildSwapMenu.ShowCheckBox:SetPosition((BuildSwapMenu:GetWidth()/2) -100+20, BuildSwapMenu:GetHeight() - 95);
BuildSwapMenu.ShowCheckBox:SetText(" Show");
BuildSwapMenu.ShowCheckBox:SetEnabled(false);

BuildSwapMenu.HideCheckBox = Turbine.UI.Lotro.CheckBox();
BuildSwapMenu.HideCheckBox:SetParent(BuildSwapMenu);
BuildSwapMenu.HideCheckBox:SetSize(100,25);
BuildSwapMenu.HideCheckBox:SetPosition((BuildSwapMenu:GetWidth()/2)+20, BuildSwapMenu:GetHeight() - 95);
BuildSwapMenu.HideCheckBox:SetText(" Hide");
BuildSwapMenu.HideCheckBox:SetEnabled(false);

BuildSwapMenu.ShowAllButton = Turbine.UI.Lotro.Button();
BuildSwapMenu.ShowAllButton:SetParent(BuildSwapMenu);
BuildSwapMenu.ShowAllButton:SetSize(100,25);
BuildSwapMenu.ShowAllButton:SetPosition((BuildSwapMenu:GetWidth()/2) -100, BuildSwapMenu:GetHeight() - 90);
BuildSwapMenu.ShowAllButton:SetText("Show All");
BuildSwapMenu.ShowAllButton:SetVisible(false);

BuildSwapMenu.HideAllButton = Turbine.UI.Lotro.Button();
BuildSwapMenu.HideAllButton:SetParent(BuildSwapMenu);
BuildSwapMenu.HideAllButton:SetSize(100,25);
BuildSwapMenu.HideAllButton:SetPosition((BuildSwapMenu:GetWidth()/2), BuildSwapMenu:GetHeight() - 90);
BuildSwapMenu.HideAllButton:SetText("Hide All");
BuildSwapMenu.HideAllButton:SetVisible(false);

BuildSwapMenu.NewButton = Turbine.UI.Lotro.Button();
BuildSwapMenu.NewButton:SetParent(BuildSwapMenu);
BuildSwapMenu.NewButton:SetPosition((BuildSwapMenu:GetWidth()/4) - 40, BuildSwapMenu:GetHeight() - 65);
BuildSwapMenu.NewButton:SetSize(80, 25);
BuildSwapMenu.NewButton:SetText("New");

BuildSwapMenu.EditButton = Turbine.UI.Lotro.Button();
BuildSwapMenu.EditButton:SetParent(BuildSwapMenu);
BuildSwapMenu.EditButton:SetPosition((BuildSwapMenu:GetWidth()/2) - 40, BuildSwapMenu:GetHeight() - 65);
BuildSwapMenu.EditButton:SetSize(80, 25);
BuildSwapMenu.EditButton:SetText("Edit");
BuildSwapMenu.EditButton:SetEnabled(false);

BuildSwapMenu.DeleteButton = Turbine.UI.Lotro.Button();
BuildSwapMenu.DeleteButton:SetParent(BuildSwapMenu);
BuildSwapMenu.DeleteButton:SetPosition((BuildSwapMenu:GetWidth()*3/4) - 40, BuildSwapMenu:GetHeight() - 65);
BuildSwapMenu.DeleteButton:SetSize(80, 25);
BuildSwapMenu.DeleteButton:SetText("Delete");
BuildSwapMenu.DeleteButton:SetEnabled(false);

BuildSwapMenu.SpawnQuickslotButton = Turbine.UI.Lotro.Button();
BuildSwapMenu.SpawnQuickslotButton:SetParent(BuildSwapMenu);
BuildSwapMenu.SpawnQuickslotButton:SetText("Spawn Singleton Quickslot");
--BuildSwapMenu.SpawnQuickslotButton:SetPosition((BuildSwapMenu:GetWidth()/4) - 40, BuildSwapMenu:GetHeight() - 35);
--BuildSwapMenu.SpawnQuickslotButton:SetSize((BuildSwapMenu:GetWidth()/2) + 80, 25);

BuildSwapMenu.SpawnQuickslotButton:SetSize(BuildSwapMenu.ListBox:GetWidth()+200, 25);
BuildSwapMenu.SpawnQuickslotButton:SetPosition((BuildSwapMenu:GetWidth() - BuildSwapMenu.SpawnQuickslotButton:GetWidth())/2, BuildSwapMenu:GetHeight() - 35)

BuildSwapMenu.selection = "";
BuildSwapMenu.GroupSelection = "";
BuildSwapMenu.IsInGroupSelectionMode = false;
BuildSwapMenu.MenuItems = {}
BuildSwapMenu.GroupWindows = {}
BuildSwapMenu.PulseList = {}
BuildSwapMenu.Time = 0;

-- ******************************* Sequence Window *****************************************

SequenceBuilder = Turbine.UI.Lotro.Window();
local SBWidth = 530;
local SBHeight = 600;
SequenceBuilder:SetSize(SBWidth, SBHeight);
SequenceBuilder:SetPosition((Turbine.UI.Display:GetWidth() - SBWidth)/2, (Turbine.UI.Display:GetHeight() - SBHeight)/2);
SequenceBuilder:SetText("Quickslot Sequence Builder");

SequenceBuilder.QuickSlotPlacer = Turbine.UI.Window();
SequenceBuilder.QuickSlotPlacer:SetSize(32,32);
SequenceBuilder.QuickSlotPlacer:SetPosition(SequenceBuilder:GetLeft() + SequenceBuilder:GetWidth() + 50, SequenceBuilder:GetTop() + 50);
SequenceBuilder.QuickSlotPlacer:SetBackground("Turwe\\BuildSwapper\\movebox.tga");
SequenceBuilder.QuickSlotPlacer:SetStretchMode(2);

SequenceBuilder.SequenceName = "";

SequenceBuilder.NameLabel = Turbine.UI.Label();
SequenceBuilder.NameLabel:SetParent(SequenceBuilder);
SequenceBuilder.NameLabel:SetSize(50, 25);
SequenceBuilder.NameLabel:SetPosition(20, 50);
SequenceBuilder.NameLabel:SetText("Name: ");
SequenceBuilder.NameLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );

SequenceBuilder.NameBox = Turbine.UI.Lotro.TextBox();
SequenceBuilder.NameBox:SetParent(SequenceBuilder);
SequenceBuilder.NameBox:SetSize(SBWidth - 170, 25);
SequenceBuilder.NameBox:SetPosition(70, 50);
SequenceBuilder.NameBox:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );

SequenceBuilder.ShowBox = Turbine.UI.Lotro.CheckBox();
SequenceBuilder.ShowBox:SetParent(SequenceBuilder);
SequenceBuilder.ShowBox:SetSize(80, 25);
SequenceBuilder.ShowBox:SetPosition(SBWidth - 80, 50);
SequenceBuilder.ShowBox:SetText(" Show");
SequenceBuilder.ShowBox:SetChecked(true);

SequenceBuilder.ResetPolicyLabel = Turbine.UI.Label();
SequenceBuilder.ResetPolicyLabel:SetParent(SequenceBuilder);
SequenceBuilder.ResetPolicyLabel:SetSize(120, 25);
SequenceBuilder.ResetPolicyLabel:SetPosition(20, 90);
SequenceBuilder.ResetPolicyLabel:SetText("Reset Policy:");
SequenceBuilder.ResetPolicyLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );

SequenceBuilder.TimeoutBox = Turbine.UI.Lotro.CheckBox();
SequenceBuilder.TimeoutBox:SetParent(SequenceBuilder);
SequenceBuilder.TimeoutBox:SetSize(100, 25);
SequenceBuilder.TimeoutBox:SetPosition((SBWidth*2/5) - 50, 90);
SequenceBuilder.TimeoutBox:SetText(" Timeout");
SequenceBuilder.TimeoutBox:SetChecked(true);
SequenceBuilder.TimeoutBox:SetEnabled(false);

SequenceBuilder.ContinuousBox = Turbine.UI.Lotro.CheckBox();
SequenceBuilder.ContinuousBox:SetParent(SequenceBuilder);
SequenceBuilder.ContinuousBox:SetSize(100, 25);
SequenceBuilder.ContinuousBox:SetPosition((SBWidth*3/5) - 50, 90);
SequenceBuilder.ContinuousBox:SetText(" Continuous");

SequenceBuilder.HideBox = Turbine.UI.Lotro.CheckBox();
SequenceBuilder.HideBox:SetParent(SequenceBuilder);
SequenceBuilder.HideBox:SetSize(100, 25);
SequenceBuilder.HideBox:SetPosition((SBWidth*4/5) - 50, 90);
SequenceBuilder.HideBox:SetText(" Hide");

-- 10 x 3 Quickslot Grid

local rowPos = 130;
local colPos = 100;
SequenceBuilder.QuickSlot = {};
SequenceBuilder.QSLabel = {};

local i = 1;
SequenceBuilder.QSLabel[1] = Turbine.UI.Label();
SequenceBuilder.QSLabel[1]:SetParent(SequenceBuilder);
SequenceBuilder.QSLabel[1]:SetPosition(10, rowPos+5);
SequenceBuilder.QSLabel[1]:SetSize(90, 25);
SequenceBuilder.QSLabel[1]:SetText("1 - 10");
SequenceBuilder.QSLabel[1]:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
for i = 1,10 do
  SequenceBuilder.QuickSlot[i] = Turbine.UI.Lotro.Quickslot();
  SequenceBuilder.QuickSlot[i]:SetParent(SequenceBuilder);
  SequenceBuilder.QuickSlot[i]:SetPosition(colPos, rowPos);
  colPos = colPos + 40;
end

rowPos = rowPos + 50;
colPos = 100;
SequenceBuilder.QSLabel[2] = Turbine.UI.Label();
SequenceBuilder.QSLabel[2]:SetParent(SequenceBuilder);
SequenceBuilder.QSLabel[2]:SetPosition(10, rowPos+5);
SequenceBuilder.QSLabel[2]:SetSize(90, 25);
SequenceBuilder.QSLabel[2]:SetText("11 - 20");
SequenceBuilder.QSLabel[2]:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
for i = 11,20 do
  SequenceBuilder.QuickSlot[i] = Turbine.UI.Lotro.Quickslot();
  SequenceBuilder.QuickSlot[i]:SetParent(SequenceBuilder);
  SequenceBuilder.QuickSlot[i]:SetPosition(colPos, rowPos);
  colPos = colPos + 40;
end

rowPos = rowPos + 50;
colPos = 100;
SequenceBuilder.QSLabel[3] = Turbine.UI.Label();
SequenceBuilder.QSLabel[3]:SetParent(SequenceBuilder);
SequenceBuilder.QSLabel[3]:SetPosition(10, rowPos+5);
SequenceBuilder.QSLabel[3]:SetSize(90, 25);
SequenceBuilder.QSLabel[3]:SetText("21 - 30");
SequenceBuilder.QSLabel[3]:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
for i = 21,30 do
  SequenceBuilder.QuickSlot[i] = Turbine.UI.Lotro.Quickslot();
  SequenceBuilder.QuickSlot[i]:SetParent(SequenceBuilder);
  SequenceBuilder.QuickSlot[i]:SetPosition(colPos, rowPos);
  colPos = colPos + 40;
end

rowPos = rowPos + 50;
SequenceBuilder.GenLabel = Turbine.UI.Label();
SequenceBuilder.GenLabel:SetParent(SequenceBuilder);
SequenceBuilder.GenLabel:SetPosition(20, rowPos + 5);
SequenceBuilder.GenLabel:SetSize(90, 25);
SequenceBuilder.GenLabel:SetText("Alias Text:");
SequenceBuilder.GenLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);

SequenceBuilder.AliasBox = Turbine.UI.Lotro.TextBox();
SequenceBuilder.AliasBox:SetParent(SequenceBuilder);
SequenceBuilder.AliasBox:SetPosition(110, rowPos + 5);
SequenceBuilder.AliasBox:SetSize(SBWidth - 130 , 25);
SequenceBuilder.AliasBox:SetMultiline(false);

rowPos = rowPos + 40;
SequenceBuilder.GenButton = Turbine.UI.Lotro.Button();
SequenceBuilder.GenButton:SetParent(SequenceBuilder);
SequenceBuilder.GenButton:SetPosition((SBWidth/2) - 120, rowPos + 10);
SequenceBuilder.GenButton:SetSize(195,25);
SequenceBuilder.GenButton:SetText("Generate Alias Quickslot");

SequenceBuilder.AliasQuickSlot = Turbine.UI.Lotro.Quickslot();
SequenceBuilder.AliasQuickSlot:SetParent(SequenceBuilder);
SequenceBuilder.AliasQuickSlot:SetPosition((SBWidth/2) - 120 + 205, rowPos); 
SequenceBuilder.AliasQuickSlot:SetAllowDrop(false);

rowPos = rowPos + 40;
SequenceBuilder.ErrorLabel = Turbine.UI.Label();
SequenceBuilder.ErrorLabel:SetParent(SequenceBuilder);
SequenceBuilder.ErrorLabel:SetPosition(20, rowPos);
SequenceBuilder.ErrorLabel:SetSize(SBWidth - 40, 25);
SequenceBuilder.ErrorLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
SequenceBuilder.ErrorLabel:SetOutlineColor( Turbine.UI.Color( 1, 0, 0 ) );
SequenceBuilder.ErrorLabel:SetFontStyle( Turbine.UI.FontStyle.Outline );
SequenceBuilder.ErrorLabel:SetFont(Turbine.UI.Lotro.Font.Verdana16);


rowPos = rowPos + 30;

SequenceBuilder.InstPanel = Turbine.UI.ListBox();
SequenceBuilder.InstPanel:SetParent(SequenceBuilder);
SequenceBuilder.InstPanel:SetPosition(20, rowPos);
SequenceBuilder.InstPanel:SetSize(SBWidth - 60, SBHeight - 65 - rowPos);
SequenceBuilder.InstPanel:SetOrientation(Turbine.UI.Orientation.Vertical);

SequenceBuilder.InstPanel.VScroll = Turbine.UI.Lotro.ScrollBar();
SequenceBuilder.InstPanel.VScroll:SetParent(SequenceBuilder);
SequenceBuilder.InstPanel.VScroll:SetOrientation(Turbine.UI.Orientation.Vertical);
SequenceBuilder.InstPanel.VScroll:SetPosition(SequenceBuilder.InstPanel:GetLeft()+SequenceBuilder.InstPanel:GetWidth(),SequenceBuilder.InstPanel:GetTop());
SequenceBuilder.InstPanel.VScroll:SetSize(12,SequenceBuilder.InstPanel:GetHeight());
SequenceBuilder.InstPanel.VScroll:SetBackColor(Turbine.UI.Color(.1,.1,.2));
SequenceBuilder.InstPanel:SetVerticalScrollBar(SequenceBuilder.InstPanel.VScroll);



SequenceBuilder.InstLabel = Turbine.UI.Label();
SequenceBuilder.InstLabel:SetParent(SequenceBuilder.InstPanel);
SequenceBuilder.InstLabel:SetPosition(0,0);
SequenceBuilder.InstLabel:SetSize(SBWidth - 60, 250);
SequenceBuilder.InstLabel:SetText("Instructions\n\nEnter as many quickslots as you would like to be sequenced.  Any gaps will be skipped.  Alias quickslots (shortcuts) can be generated via the generator above or entered into your standard quickslots via the /shortcut [quickslot number] [alias command] and then dragged in.  Keep in mind that only one ring, earring, wrist, or 1h weapon can be swapped without first unequipping what is in the second slot.  The /buildswapper unequip command is provided for this purpose. To perform a swap of both rings, for example, you would first need to enter the quickslot '/buildswapper unequip rings', which will unequip both of your rings.  You can then proceed to enter in both ring swaps and both new rings will be equipped. The /buildswapper unequip wrists, /buildswapper unequip earrings, and /buildswapper unequip weapons commands are provided for this purpose.  To see a list of all valid slot names type /buildswapper unequip.");--  In certain circumstances, unequipping both items in a particular slot might be too detrimental (mid-combat, for instance).  For this purpose, ring2, earring2, wrist2, and weapon2 are also valid slot names to be provided to the /unequip command, in order to enable secondary slots to be unequipped. However, use these with caution.  If you execute a quickslot sequence like the following: Equip ringA, /unequip ring2, equip ringB  and ringA is already equipped in the 2nd slot, nothing will happen when you try to equip ringA (it's already equipped!), then the unequip command will unequip ringA (it's in slot 2!), then ringB will either get equipped to slot2 (leaving out the ringA swap) or, if you're already wearing ringB too, you will be left with no ring in your 2nd slot.  Future versions of this plugin will automatically correct this issue, but it is recommended that you unequip both rings, wrists, earrings, or weapons before performing attempting to swap both.");
SequenceBuilder.InstLabel:SetTextAlignment(Turbine.UI.ContentAlignment.TopCenter);
SequenceBuilder.InstPanel:AddItem(SequenceBuilder.InstLabel);



SequenceBuilder.SaveButton = Turbine.UI.Lotro.Button();
SequenceBuilder.SaveButton:SetParent(SequenceBuilder);
SequenceBuilder.SaveButton:SetSize(100, 25);
SequenceBuilder.SaveButton:SetPosition((SBWidth/2) - 50, SBHeight - 35);
SequenceBuilder.SaveButton:SetText("Save");

SequenceBuilder.CustomCloseButton = Turbine.UI.Window();
SequenceBuilder.CustomCloseButton:SetParent( SequenceBuilder );
SequenceBuilder.CustomCloseButton:SetSize( 16, 16 );
SequenceBuilder.CustomCloseButton:SetPosition( SequenceBuilder:GetWidth() - 21, 21)
SequenceBuilder.CustomCloseButton:SetBackground("Turwe\\BuildSwapper\\TurbineRedXButton2.tga");
SequenceBuilder.CustomCloseButton:SetVisible(true);
-- ********************************* End Sequence Window Initialization *******************************************************


-- *******************************************************************************************************************
--              Sequence Builder Functions
-- *******************************************************************************************************************


SequenceBuilder.GenButton.MouseClick = function()
  local AliasText = SequenceBuilder.AliasBox:GetText();  
  SequenceBuilder.AliasQuickSlot:SetShortcut( Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, AliasText ) ); 
end

SequenceBuilder.AliasBox.KeyDown = function(sender, args)
  if (not (args.Action == null)) then
    if args.Action == 162 then
      local AliasText = SequenceBuilder.AliasBox:GetText();  
      SequenceBuilder.AliasQuickSlot:SetShortcut( Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, AliasText ) );  
    end
  end
end

local j = 1
SequenceBuilder.MouseDownOnQuickSlot = false;
SequenceBuilder.IsDraggingAlias = false;
SequenceBuilder.IsDraggingSomething = false;
SequenceBuilder.DraggedAliasData = "";
SequenceBuilder.SourceIndex = 0;
SequenceBuilder.PotentialSwapShortcut = nil;
SequenceBuilder.Time = 0;
for j = 1,30 do
  SequenceBuilder.QuickSlot[j].DragEntered = false;
  
  -- ****************  Custom Drag Drop functionality  *******************************
  SequenceBuilder.QuickSlot[j].MouseDown = function()
    --Turbine.Shell.WriteLine("MouseDown fired.");
    SequenceBuilder.MouseDownOnQuickSlot = true;
  end
  
  -- NOTE!  MouseLeave events seem to get fired before DragLeave events... let us hope
  -- this is always the case
  -- If the mouse is down, set the dragging something flag and clear the quickslot.
  -- Additionally, if the quickslot is holding an alias, store the alias data for the
  -- drop.
  SequenceBuilder.QuickSlot[j].MouseLeave = function()
    --Turbine.Shell.WriteLine("MouseLeave fired.");
    if SequenceBuilder.MouseDownOnQuickSlot then
      SequenceBuilder.IsDraggingSomething = true;
      SequenceBuilder.SourceIndex = j;
      SequenceBuilder.MouseDownOnQuickSlot = false;
      
      if (SequenceBuilder.QuickSlot[j]:GetShortcut():GetType() == Turbine.UI.Lotro.ShortcutType.Alias) then
        --Turbine.Shell.WriteLine("Dragging alias detected.");
        SequenceBuilder.IsDraggingAlias = true;
        SequenceBuilder.DraggedAliasData = SequenceBuilder.QuickSlot[j]:GetShortcut():GetData();
      else
        -- This is necessary to mitigate the damage from the alias quickslot bug
        SequenceBuilder.IsDraggingAlias = false;
      end
      SequenceBuilder.QuickSlot[j]:SetShortcut(Turbine.UI.Lotro.Shortcut());
    end
  end
  
  SequenceBuilder.QuickSlot[j].MouseUp = function()
    --Turbine.Shell.WriteLine("MouseUp fired");
    SequenceBuilder.MouseDownOnQuickSlot = false;
  end
  -- ******************** End Custom Alias Drag Drop Functionality ******************************
  
  SequenceBuilder.QuickSlot[j].DragEnter = function()
    if SequenceBuilder.IsDraggingSomething then
      SequenceBuilder.PotentialSwapShortcut = SequenceBuilder.QuickSlot[j]:GetShortcut();
    end
  end
  
  SequenceBuilder.QuickSlot[j].DragLeave = function()
    SequenceBuilder.PotentialSwapShortcut = nil;
  end
  
  -- Since alias quickslots are broken, we have to manually set the quickslot
  SequenceBuilder.QuickSlot[j].DragDrop = function(sender, args)
    -- FIRST! Check to make sure that, if SequenceBuilder actually thinks its dragging an alias, that
    -- args is messed up like it should be (this probably means the dragging alias flag is unnecessary
    -- but it will work like this, so I'm leaving it)
    if (SequenceBuilder.IsDraggingAlias and (not ( args["DragDropInfo"]:GetShortcut() == nil )) ) then
      SequenceBuilder.IsDraggingAlias = false;
      SequenceBuilder.IsDraggingSomething = false;
    end
    
    if ( SequenceBuilder.IsDraggingSomething and (not (SequenceBuilder.SourceIndex == 0)) and (not (SequenceBuilder.SourceIndex == j)) ) then
      SequenceBuilder.QuickSlot[SequenceBuilder.SourceIndex]:SetShortcut(SequenceBuilder.PotentialSwapShortcut)
    end
    
    if SequenceBuilder.IsDraggingAlias then
      SequenceBuilder.QuickSlot[j]:SetShortcut(Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, SequenceBuilder.DraggedAliasData));
      SequenceBuilder.IsDraggingAlias = false;
    end
    
    
    SequenceBuilder.IsDraggingSomething = false; 
    SequenceBuilder.SourceIndex = 0;   
  end
end

-- ********************* Alias Quickslot Custom Drag Drop ***********************************

SequenceBuilder.AliasQuickSlot.MouseDown = function()
  --Turbine.Shell.WriteLine("MouseDown fired.");
  SequenceBuilder.MouseDownOnQuickSlot = true;
end
  
-- NOTE!  MouseLeave events seem to get fired before DragLeave events... let us hope
-- this is always the case
SequenceBuilder.AliasQuickSlot.MouseLeave = function()
  --Turbine.Shell.WriteLine("MouseLeave fired.");
  if SequenceBuilder.MouseDownOnQuickSlot then
    SequenceBuilder.IsDraggingSomething = true;
    SequenceBuilder.SourceIndex = 0;
    SequenceBuilder.MouseDownOnQuickSlot = false;
    
    SequenceBuilder.IsDraggingAlias = true;
    SequenceBuilder.DraggedAliasData = SequenceBuilder.AliasQuickSlot:GetShortcut():GetData();
  end
end
  
  SequenceBuilder.QuickSlot[j].MouseUp = function()
    --Turbine.Shell.WriteLine("MouseUp fired");
    SequenceBuilder.MouseDownOnQuickSlot = false;
  end
  
-- *******************************************************************************************

SequenceBuilder.TimeoutBox.CheckedChanged = function()
  if(SequenceBuilder.TimeoutBox:IsChecked()) then
    SequenceBuilder.TimeoutBox:SetEnabled(false);
    SequenceBuilder.ContinuousBox:SetChecked(false);
    SequenceBuilder.HideBox:SetChecked(false);
  else
    SequenceBuilder.TimeoutBox:SetEnabled(true);
  end
end

SequenceBuilder.HideBox.CheckedChanged = function()
  if(SequenceBuilder.HideBox:IsChecked()) then
    SequenceBuilder.HideBox:SetEnabled(false);
    SequenceBuilder.TimeoutBox:SetChecked(false);
    SequenceBuilder.ContinuousBox:SetChecked(false);
  else
    SequenceBuilder.HideBox:SetEnabled(true);
  end
end

SequenceBuilder.ContinuousBox.CheckedChanged = function()
  if(SequenceBuilder.ContinuousBox:IsChecked()) then
    SequenceBuilder.ContinuousBox:SetEnabled(false);
    SequenceBuilder.TimeoutBox:SetChecked(false);
    SequenceBuilder.HideBox:SetChecked(false);
  else
    SequenceBuilder.ContinuousBox:SetEnabled(true);
  end  
end

SequenceBuilder.SaveButton.MouseClick = function()
  Controller.ProcessSave();
end

SequenceBuilder.CustomCloseButton.MouseClick = function()
  if(not (SequenceBuilder.ConfirmCloseWindow == nil)) then
    SequenceBuilder.ConfirmCloseWindow:SetPosition((SequenceBuilder:GetWidth()/2) - 100 + SequenceBuilder:GetLeft(), (SequenceBuilder:GetHeight()/2) - 40 + SequenceBuilder:GetTop());
    SequenceBuilder.ConfirmCloseWindow:SetZOrder(SequenceBuilder:GetZOrder() + 1);
    SequenceBuilder.ConfirmCloseWindow:SetVisible(true);
    do return end
  end
  
  SequenceBuilder.ConfirmCloseWindow = Turbine.UI.Lotro.Window()
  SequenceBuilder.ConfirmCloseWindow:SetText("Save?");
  SequenceBuilder.ConfirmCloseWindow:SetSize(200, 70);
  SequenceBuilder.ConfirmCloseWindow:SetPosition((SequenceBuilder:GetWidth()/2) - 100 + SequenceBuilder:GetLeft(), (SequenceBuilder:GetHeight()/2) - 40 + SequenceBuilder:GetTop());
  SequenceBuilder.ConfirmCloseWindow:SetVisible(true);
  
  SequenceBuilder.ConfirmCloseWindow.YesButton = Turbine.UI.Lotro.Button()
  SequenceBuilder.ConfirmCloseWindow.YesButton:SetParent(SequenceBuilder.ConfirmCloseWindow);
  SequenceBuilder.ConfirmCloseWindow.YesButton:SetSize(70, 25)
  SequenceBuilder.ConfirmCloseWindow.YesButton:SetPosition(20,45)
  SequenceBuilder.ConfirmCloseWindow.YesButton:SetText("Yes"); 
  
  SequenceBuilder.ConfirmCloseWindow.NoButton = Turbine.UI.Lotro.Button()
  SequenceBuilder.ConfirmCloseWindow.NoButton:SetParent(SequenceBuilder.ConfirmCloseWindow);
  SequenceBuilder.ConfirmCloseWindow.NoButton:SetSize(70, 25)
  SequenceBuilder.ConfirmCloseWindow.NoButton:SetPosition(110,45)
  SequenceBuilder.ConfirmCloseWindow.NoButton:SetText("No");
  
  SequenceBuilder.ConfirmCloseWindow.YesButton.MouseClick = function()
    SequenceBuilder.ConfirmCloseWindow:SetVisible(false);
    SequenceBuilder.ConfirmCloseWindow = nil;
    Controller.ProcessSave();
  end
  
  SequenceBuilder.ConfirmCloseWindow.NoButton.MouseClick = function()
    SequenceBuilder.ConfirmCloseWindow:SetVisible(false);
    SequenceBuilder.ConfirmCloseWindow = nil;
    SequenceBuilder:Close();
  end
end

SequenceBuilder.Update = function()
  timeDiff = Turbine.Engine.GetGameTime() - SequenceBuilder.Time
  if(timeDiff >= 2) then
    SequenceBuilder.Time = SequenceBuilder.Time + 2;
    timeDiff = timeDiff - 2;
  end
  
  if(timeDiff > 1) then
    SequenceBuilder.QuickSlotPlacer:SetOpacity(.5 + ((timeDiff - 1)/2));
  else
    SequenceBuilder.QuickSlotPlacer:SetOpacity(1 - (timeDiff/2));
  end
end

SequenceBuilder.Open = function()
  SequenceBuilder:SetVisible(true);
  SequenceBuilder.Time = Turbine.Engine.GetGameTime()
  SequenceBuilder:SetWantsUpdates(true);
end

SequenceBuilder.Closing = function()
  SequenceBuilder.ConfirmCloseWindow = nil;
  SequenceBuilder.QuickSlotPlacer:Close();
  BuildSwapMenu.Open()
  if (not (BuildSwapMenu.selection == "")) then
    SequenceWindows[BuildSwapMenu.selection]:SetVisible(BuildTable[BuildSwapMenu.selection].Shown);
    if(BuildTable[BuildSwapMenu.selection].Shown) then
      BuildSwapMenu.ShowCheckBox:SetChecked(true);
    else
      BuildSwapMenu.HideCheckBox:SetChecked(true);
    end
  end
end

SequenceBuilder.QuickSlotPlacer.isMoving = false;
SequenceBuilder.QuickSlotPlacer.xOffset = 0;
SequenceBuilder.QuickSlotPlacer.yOffset = 0;

SequenceBuilder.QuickSlotPlacer.MouseMove = function()
  if SequenceBuilder.QuickSlotPlacer.isMoving then
    SequenceBuilder.QuickSlotPlacer:SetOpacity(1)
    SequenceBuilder:SetWantsUpdates(false);
    local curX, curY = SequenceBuilder.QuickSlotPlacer:GetPosition();
    local newXOffset, newYOffset = SequenceBuilder.QuickSlotPlacer:GetMousePosition();
    SequenceBuilder.QuickSlotPlacer:SetPosition(curX + newXOffset - SequenceBuilder.QuickSlotPlacer.xOffset, curY + newYOffset - SequenceBuilder.QuickSlotPlacer.yOffset);
  end
end

SequenceBuilder.QuickSlotPlacer.MouseDown = function()
  --Turbine.Shell.WriteLine("Mouse down");
  SequenceBuilder.QuickSlotPlacer.xOffset, SequenceBuilder.QuickSlotPlacer.yOffset = SequenceBuilder.QuickSlotPlacer:GetMousePosition();
  SequenceBuilder.QuickSlotPlacer.isMoving = true;
end

SequenceBuilder.QuickSlotPlacer.MouseUp = function()
  --Turbine.Shell.WriteLine("Mouse up");
  SequenceBuilder.QuickSlotPlacer.isMoving = false;
end



-- *******************************************************************************************************************
--              Controller Functions
-- *******************************************************************************************************************

Controller.Delete = function( i )
  --BuildSwapMenu.ListBox:RemoveItem(BuildSwapMenu.GroupWindows[i]);
  
  BuildSwapMenu.GroupWindows[BuildTable[i].Group].RemoveItem(i);
  BuildSwapMenu.MenuItems[i] = nil;
  
  BuildTable[i] = nil;  
  
  SequenceWindows[i]:SetVisible(false);
  SequenceWindows[i] = nil;  
  
  BuildSwapMenu.HideCheckBox:SetChecked(false);
  BuildSwapMenu.HideCheckBox:SetEnabled(false);
  BuildSwapMenu.ShowCheckBox:SetChecked(false);
  BuildSwapMenu.ShowCheckBox:SetEnabled(false);
  BuildSwapMenu.EditButton:SetEnabled(false);
  BuildSwapMenu.DeleteButton:SetEnabled(false);
  BuildSwapMenu.selection = "";
end

Controller.DisplayNewSequenceBuilderWindow = function()
  SequenceBuilder.SequenceName = "";

  SequenceBuilder.NameBox:SetText("");
  SequenceBuilder.ShowBox:SetChecked(true);
  SequenceBuilder.TimeoutBox:SetChecked(true);
  SequenceBuilder.AliasBox:SetText("");
  SequenceBuilder.AliasQuickSlot:SetShortcut(Turbine.UI.Lotro.Shortcut())
  SequenceBuilder.ErrorLabel:SetText("");
  for i = 1,30 do
    SequenceBuilder.QuickSlot[i]:SetShortcut(Turbine.UI.Lotro.Shortcut());
  end
  SequenceBuilder.QuickSlotPlacer:SetPosition(SequenceBuilder:GetLeft() + SequenceBuilder:GetWidth() + 50,SequenceBuilder:GetTop() + 50);
  
  SequenceBuilder.Open();
  SequenceBuilder.QuickSlotPlacer:SetVisible(true);
end

Controller.DisplaySequenceBuilderWindow = function( i )
  local seq = BuildTable[i]
  
  SequenceBuilder.SequenceName = i;
  SequenceBuilder.NameBox:SetText(i);
  SequenceBuilder.ShowBox:SetChecked( seq.Shown );
  
  if seq.ResetPolicy == ResetPolicy.Timeout then
    SequenceBuilder.TimeoutBox:SetChecked(true);
  elseif seq.ResetPolity == ResetPolicy.Continuous then
    SequenceBuilder.ContinuousBox:SetChecked(true);
  else
    SequenceBuilder.HideBox:SetChecked(true);
  end
  
  SequenceBuilder.AliasBox:SetText("");
  SequenceBuilder.AliasQuickSlot:SetShortcut(Turbine.UI.Lotro.Shortcut())
  SequenceBuilder.ErrorLabel:SetText("");
  
  for j = 1,30 do
    SequenceBuilder.QuickSlot[j]:SetShortcut(Turbine.UI.Lotro.Shortcut(seq.QuickSlotType[j], seq.QuickSlotData[j]));
  end
  SequenceBuilder.QuickSlotPlacer:SetPosition(seq.XPos+2, seq.YPos+2);

  SequenceBuilder.Open();
  SequenceBuilder.QuickSlotPlacer:SetVisible(true);
  SequenceWindows[i]:SetVisible(false);
  SequenceWindows[i]:StopTimeout();
  
end

Controller.Show = function( i )
  SequenceWindows[i]:SetVisible(true);
  BuildTable[i].Shown = true;
  if(BuildSwapMenu.selection == i) then
    BuildSwapMenu.ShowCheckBox:SetChecked(true);
  end
  BuildSwapMenu.MenuItems[i]:SetForeColor( Turbine.UI.Color(1,1,1) );
end

Controller.Hide = function( i )
  SequenceWindows[i]:SetVisible(false);
  BuildTable[i].Shown = false;
  if(BuildSwapMenu.selection == i) then
    BuildSwapMenu.HideCheckBox:SetChecked(true);
  end
  BuildSwapMenu.MenuItems[i]:SetForeColor( Turbine.UI.Color(.5,.5,.5) );
end

-- *******************************************************************************************************************
--                                      Sequence Window Functions
-- *******************************************************************************************************************
Controller.InitializeSequenceWindow = function( i )
  SequenceWindows[i] = Turbine.UI.Window();
  SequenceWindows[i]:SetSize(35,35);
    
  SequenceWindows[i].Index = 0;
  --SequenceWindows[i].QuickSlotSequence = {}
  --SequenceWindows[i].QuickSlotSequence.Length = 0;
  
  SequenceWindows[i].MovePanel = Turbine.UI.Control()
  SequenceWindows[i].MovePanel:SetParent(SequenceWindows[i]);
  SequenceWindows[i].MovePanel:SetSize(35,35);
  SequenceWindows[i].MovePanel:SetPosition(0,0);
  SequenceWindows[i].MovePanel:SetAllowDrop(false);
  SequenceWindows[i].MovePanel:SetBackground("Turwe\\BuildSwapper\\MoveOverlay.tga");
  SequenceWindows[i].MovePanel:SetStretchMode(2);
  SequenceWindows[i].MovePanel:SetOpacity(.5);
  if(Controller.UIEditMode) then
    SequenceWindows[i].MovePanel:SetVisible(true)
  else
    SequenceWindows[i].MovePanel:SetVisible(false)
  end

  
  SequenceWindows[i].MovePanel.MouseDown = function()
    SequenceWindows[i].MouseIsDown = true;
    SequenceWindows[i].xOffset, SequenceWindows[i].yOffset = SequenceWindows[i]:GetMousePosition();
  end
  
  SequenceWindows[i].MovePanel.MouseUp = function()
    SequenceWindows[i].MouseIsDown = false;
    -- Grab X, Y coords of new quickslot loc
    BuildTable[i].XPos = SequenceWindows[i]:GetLeft();
    BuildTable[i].YPos = SequenceWindows[i]:GetTop();
    Turbine.PluginData.Save(Turbine.DataScope.Character, "BuildSwapper", BuildTable);
  end
  
  SequenceWindows[i].MovePanel.MouseMove = function()
    if SequenceWindows[i].MouseIsDown then
      local curX, curY = SequenceWindows[i]:GetPosition();
      local newXOffset, newYOffset = SequenceWindows[i]:GetMousePosition();
      SequenceWindows[i]:SetPosition(curX + newXOffset - SequenceWindows[i].xOffset, curY + newYOffset - SequenceWindows[i].yOffset);
    end
  end
    
  -- *************** Sequence Window Code *************************************
  SequenceWindows[i].QuickSlotClicked = function()
    
    local j = SequenceWindows[i].Index + 1;
    
    if(j > SequenceWindows[i].QuickSlotSequence.Length) then
      SequenceWindows[i].EndReached();
    else
      SequenceWindows[i].Index = j;
      SequenceWindows[i].QuickSlotSequence[j-1]:SetVisible(false);
      SequenceWindows[i].QuickSlotSequence[j]:SetVisible(true);
    end
  end
  
  SequenceWindows[i].EndReached = function()
    Turbine.Shell.WriteLine("End reached for "..i);
    if(BuildTable[i].ResetPolicy == ResetPolicy.Hide) then
      SequenceWindows[i].ExecuteEnd_Hide();
    elseif BuildTable[i].ResetPolicy == ResetPolicy.Continuous then
      SequenceWindows[i].ExecuteEnd_Continous();
    elseif BuildTable[i].ResetPolicy == ResetPolicy.Timeout then
      SequenceWindows[i].ExecuteEnd_Timeout();
    else  -- This will never happen unless I put in more and forget to change this
      Turbine.Shell.WriteLine("Unknown Reset Policy encountered.");
    end
  end
  
  -- Reset, then hide
  SequenceWindows[i].ExecuteEnd_Hide = function()
    SequenceWindows[i].Reset()
    Controller.Hide(i);
  end
  
  -- Just reset
  SequenceWindows[i].ExecuteEnd_Continous = function()
    SequenceWindows[i].Reset()
  end
  
  -- Timeout and reset
  SequenceWindows[i].ExecuteEnd_Timeout = function()
    SequenceWindows[i].StartTime = Turbine.Engine.GetGameTime();
    SequenceWindows[i].EndTime = SequenceWindows[i].StartTime + 2;
    SequenceWindows[i]:SetWantsUpdates(true);
    SequenceWindows[i]:SetVisible(false);
    SequenceWindows[i].Reset()
  end
  
  SequenceWindows[i].Reset = function()
    if(SequenceWindows[i].Index > 0) then
      SequenceWindows[i].QuickSlotSequence[SequenceWindows[i].Index]:SetVisible(false);
      SequenceWindows[i].Index = 1;
      SequenceWindows[i].QuickSlotSequence[1]:SetVisible(true);
    end
  end
  
  SequenceWindows[i].Update = function()
    if Turbine.Engine.GetGameTime() > SequenceWindows[i].EndTime then
      SequenceWindows[i]:SetVisible(true);
      SequenceWindows[i]:SetWantsUpdates(false);
    end
  end
  
  SequenceWindows[i].StopTimeout = function()
    SequenceWindows[i]:SetWantsUpdates(false);
  end
end

Controller.GenerateQuickSlotTable = function(i)
  local QuickSlotSequence = {}
  QuickSlotSequence.Length = 0;
  for j = 1,30 do
    if (not (BuildTable[i].QuickSlotType[j] == 0)) then
      QuickSlotSequence.Length = QuickSlotSequence.Length + 1;
      QuickSlotSequence[QuickSlotSequence.Length] = Turbine.UI.Lotro.Quickslot();
      QuickSlotSequence[QuickSlotSequence.Length]:SetParent(SequenceWindows[i]);
      QuickSlotSequence[QuickSlotSequence.Length]:SetShortcut( Turbine.UI.Lotro.Shortcut(BuildTable[i].QuickSlotType[j], BuildTable[i].QuickSlotData[j]) );
      QuickSlotSequence[QuickSlotSequence.Length]:SetVisible(false);
      QuickSlotSequence[QuickSlotSequence.Length].MouseClick = function()
        SequenceWindows[i].QuickSlotClicked();
      end
    end
  end
  return QuickSlotSequence
end

Controller.GenerateSequenceWindow = function( i )
  if(SequenceWindows[i] == nil) then
    Controller.InitializeSequenceWindow(i);
  end
  
  SequenceWindows[i]:SetPosition(BuildTable[i].XPos, BuildTable[i].YPos);
  
  SequenceWindows[i].QuickSlotSequence = Controller.GenerateQuickSlotTable(i);
  if(SequenceWindows[i].QuickSlotSequence.Length > 0) then
    SequenceWindows[i].QuickSlotSequence[1]:SetVisible(true);
    SequenceWindows[i].Index = 1;
  else
    SequenceWindows[i].EmptyQuickSlot = Turbine.UI.Lotro.Quickslot();
    SequenceWindows[i].EmptyQuickSlot:SetParent(SequenceWindows[i]);
    SequenceWindows[i].EmptyQuickSlot:SetPosition(0,0);
    SequenceWindows[i].EmptyQuickSlot:SetAllowDrop(false);
  end
  
  if(BuildTable[i].Shown) then
    SequenceWindows[i]:SetVisible(true);
  else
    SequenceWindows[i]:SetVisible(false);
  end
end

Controller.UpdateSequenceWindow = function( i )
  
  SequenceWindows[i]:SetPosition(BuildTable[i].XPos, BuildTable[i].YPos);
  
  -- Delete the old quickslot sequence
  for name, quickslot in pairs(SequenceWindows[i].QuickSlotSequence) do
    if(not(name == "Length")) then
      quickslot:SetVisible(false);
      SequenceWindows[i].QuickSlotSequence[name] = nil;
    end
  end
  
  SequenceWindows[i].QuickSlotSequence = Controller.GenerateQuickSlotTable(i);
  if(SequenceWindows[i].QuickSlotSequence.Length > 0) then
    if (not (SequenceWindows[i].EmptyQuickSlot == null)) then
      SequenceWindows[i].EmptyQuickSlot:SetVisible(false);
      SequenceWindows[i].EmptyQuickSlot = nil;
    end
    SequenceWindows[i].QuickSlotSequence[1]:SetVisible(true);
    SequenceWindows[i].Index = 1;
  else
    if(SequenceWindows[i].EmptyQuickSlot == null) then
      SequenceWindows[i].EmptyQuickSlot = Turbine.UI.Lotro.Quickslot();
      SequenceWindows[i].EmptyQuickSlot:SetParent(SequenceWindows[i]);
      SequenceWindows[i].EmptyQuickSlot:SetPosition(0,0);
      SequenceWindows[i].EmptyQuickSlot:SetAllowDrop(false);
    else
      SequenceWindows[i].EmptyQuickSlot:SetVisible(true);
    end
  end
  
  if(BuildTable[i].Shown) then
    SequenceWindows[i]:SetVisible(true);
  else
    SequenceWindows[i]:SetVisible(false);
  end
end

Controller.RemoveGroupFromMenu = function( GName )
  GroupList[GName] = nil
  BuildSwapMenu.ListBox:RemoveItem(BuildSwapMenu.GroupWindows[GName]);
end

Controller.AddGroupToMenu = function( newGroupName )
  GroupList[newGroupName] = true;

  BuildSwapMenu.GroupWindows[newGroupName] = Turbine.UI.Label()
  BuildSwapMenu.GroupWindows[newGroupName]:SetSize( 340, 30 );
  BuildSwapMenu.GroupWindows[newGroupName]:SetVisible(true);
  BuildSwapMenu.GroupWindows[newGroupName].numItems = 0;
  BuildSwapMenu.GroupWindows[newGroupName].MenuItemsNames = {}
  BuildSwapMenu.GroupWindows[newGroupName].IsHighlighted = false;
  

  BuildSwapMenu.GroupWindows[newGroupName].TitleBar = Turbine.UI.Label();
  BuildSwapMenu.GroupWindows[newGroupName].TitleBar:SetParent( BuildSwapMenu.GroupWindows[newGroupName] );
  BuildSwapMenu.GroupWindows[newGroupName].TitleBar:SetText( " "..newGroupName );
  BuildSwapMenu.GroupWindows[newGroupName].TitleBar:SetSize( 340, 30 );
  BuildSwapMenu.GroupWindows[newGroupName].TitleBar:SetOutlineColor( Turbine.UI.Color( 0, 0, 0 ) );
  BuildSwapMenu.GroupWindows[newGroupName].TitleBar:SetFontStyle( Turbine.UI.FontStyle.Outline );
  BuildSwapMenu.GroupWindows[newGroupName].TitleBar:SetFont(Turbine.UI.Lotro.Font.Verdana18);
  BuildSwapMenu.GroupWindows[newGroupName].TitleBar:SetTextAlignment( Turbine.UI.ContentAlignment.BottomLeft );
  
  if(not(newGroupName == "General")) then
    BuildSwapMenu.GroupWindows[newGroupName].DeleteButton = Turbine.UI.Label();
    BuildSwapMenu.GroupWindows[newGroupName].DeleteButton:SetParent( BuildSwapMenu.GroupWindows[newGroupName].TitleBar );
    BuildSwapMenu.GroupWindows[newGroupName].DeleteButton:SetSize( 16, 16 );
    BuildSwapMenu.GroupWindows[newGroupName].DeleteButton:SetPosition( BuildSwapMenu.GroupWindows[newGroupName].TitleBar:GetWidth() - 20, (BuildSwapMenu.GroupWindows[newGroupName].TitleBar:GetHeight() -16)/2)
    BuildSwapMenu.GroupWindows[newGroupName].DeleteButton:SetBackground("Turwe\\BuildSwapper\\TurbineRedXButtonBlue.tga");
    BuildSwapMenu.GroupWindows[newGroupName].DeleteButton:SetVisible(true);
    
    BuildSwapMenu.GroupWindows[newGroupName].DeleteButton.MouseClick = function()
      local w = 400;
      local h = 80;
      if(not (BuildSwapMenu.GroupWindows[newGroupName].DeleteButton.ConfirmDialog == nil)) then
        BuildSwapMenu.GroupWindows[newGroupName].DeleteButton.ConfirmDialog:SetPosition(BuildSwapMenu:GetLeft() + (BuildSwapMenu:GetWidth()/2) - (w/2), BuildSwapMenu:GetTop() + (BuildSwapMenu:GetHeight()/2) - (h/2));
        BuildSwapMenu.GroupWindows[newGroupName].DeleteButton.ConfirmDialog:SetZOrder(BuildSwapMenu:GetZOrder() + 1);
        BuildSwapMenu.GroupWindows[newGroupName].DeleteButton.ConfirmDialog:SetVisible(true);
        do return end
      end
      BuildSwapMenu.GroupWindows[newGroupName].DeleteButton.ConfirmDialog = Turbine.UI.Lotro.Window()
      BuildSwapMenu.GroupWindows[newGroupName].DeleteButton.ConfirmDialog:SetSize(w,h)
      BuildSwapMenu.GroupWindows[newGroupName].DeleteButton.ConfirmDialog:SetPosition(BuildSwapMenu:GetLeft() + (BuildSwapMenu:GetWidth()/2) - (w/2), BuildSwapMenu:GetTop() + (BuildSwapMenu:GetHeight()/2) - (h/2));
      BuildSwapMenu.GroupWindows[newGroupName].DeleteButton.ConfirmDialog:SetText("Delete Group?")
      BuildSwapMenu.GroupWindows[newGroupName].DeleteButton.ConfirmDialog:SetZOrder(BuildSwapMenu:GetZOrder() + 1);
      BuildSwapMenu.GroupWindows[newGroupName].DeleteButton.ConfirmDialog:SetVisible(true);
      
      BuildSwapMenu.GroupWindows[newGroupName].DeleteButton.ConfirmDialog.InstLabel = Turbine.UI.Label()
      BuildSwapMenu.GroupWindows[newGroupName].DeleteButton.ConfirmDialog.InstLabel:SetParent(BuildSwapMenu.GroupWindows[newGroupName].DeleteButton.ConfirmDialog);
      BuildSwapMenu.GroupWindows[newGroupName].DeleteButton.ConfirmDialog.InstLabel:SetText("Are you sure you want to delete group \""..newGroupName.."\" and all of its contents?")
      BuildSwapMenu.GroupWindows[newGroupName].DeleteButton.ConfirmDialog.InstLabel:SetSize(w - 40, 25)
      BuildSwapMenu.GroupWindows[newGroupName].DeleteButton.ConfirmDialog.InstLabel:SetPosition(20, 40)
      BuildSwapMenu.GroupWindows[newGroupName].DeleteButton.ConfirmDialog.InstLabel:SetTextAlignment(Turbine.UI.ContentAlignment.BottomLeft)
      
      
      BuildSwapMenu.GroupWindows[newGroupName].DeleteButton.ConfirmDialog.YesButton = Turbine.UI.Lotro.Button()
      BuildSwapMenu.GroupWindows[newGroupName].DeleteButton.ConfirmDialog.YesButton:SetParent(BuildSwapMenu.GroupWindows[newGroupName].DeleteButton.ConfirmDialog);
      BuildSwapMenu.GroupWindows[newGroupName].DeleteButton.ConfirmDialog.YesButton:SetSize(80, 25)
      BuildSwapMenu.GroupWindows[newGroupName].DeleteButton.ConfirmDialog.YesButton:SetPosition((w/3) - 40, h - 10)
      BuildSwapMenu.GroupWindows[newGroupName].DeleteButton.ConfirmDialog.YesButton:SetText("Yes")
      BuildSwapMenu.GroupWindows[newGroupName].DeleteButton.ConfirmDialog.YesButton.MouseClick = function()
        BuildSwapMenu.GroupWindows[newGroupName].DeleteGroup();
        BuildSwapMenu.GroupWindows[newGroupName].DeleteButton.ConfirmDialog:Close()
        BuildSwapMenu.GroupWindows[newGroupName].DeleteButton.ConfirmDialog = nil;
      end
      
      BuildSwapMenu.GroupWindows[newGroupName].DeleteButton.ConfirmDialog.NoButton = Turbine.UI.Lotro.Button()
      BuildSwapMenu.GroupWindows[newGroupName].DeleteButton.ConfirmDialog.NoButton:SetParent(BuildSwapMenu.GroupWindows[newGroupName].DeleteButton.ConfirmDialog);
      BuildSwapMenu.GroupWindows[newGroupName].DeleteButton.ConfirmDialog.NoButton:SetSize(80, 25)
      BuildSwapMenu.GroupWindows[newGroupName].DeleteButton.ConfirmDialog.NoButton:SetPosition((2*w/3) - 40, h - 10)
      BuildSwapMenu.GroupWindows[newGroupName].DeleteButton.ConfirmDialog.NoButton:SetText("No")
      BuildSwapMenu.GroupWindows[newGroupName].DeleteButton.ConfirmDialog.NoButton.MouseClick = function()
        BuildSwapMenu.GroupWindows[newGroupName].DeleteButton.ConfirmDialog:Close()
        BuildSwapMenu.GroupWindows[newGroupName].DeleteButton.ConfirmDialog = nil;
      end
    end
    
    BuildSwapMenu.GroupWindows[newGroupName].DeleteGroup = function()
      if(BuildSwapMenu.GroupWindows[newGroupName].IsHighlighted) then
        BuildSwapMenu.DeselectGroup(newGroupName);
        BuildSwapMenu.SetGroupSelectionMode(false);
      end
      for a, MIName in pairs(BuildSwapMenu.GroupWindows[newGroupName].MenuItemsNames) do
        Controller.Delete(MIName);
      end
      Controller.RemoveGroupFromMenu(newGroupName);
    end
  end
  
  BuildSwapMenu.ListBox:InsertItem( BuildSwapMenu.ListBox:GetItemCount(), BuildSwapMenu.GroupWindows[newGroupName] );
  --BuildSwapMenu.GroupWindows[newGroupName]:SetZOrder(-100);
  --BuildSwapMenu.GroupWindows[newGroupName].TitleBar:SetZOrder(-101);
  
  BuildSwapMenu.GroupWindows[newGroupName].TitleBar:SetBackground("Turwe\\BuildSwapper\\MenuGroupBar.tga");
  --BuildSwapMenu.GroupWindows[newGroupName].TitleBar:SetStretchMode(2);
  BuildSwapMenu.GroupWindows[newGroupName].TitleBar:SetOpacity(.8);
  --BuildSwapMenu.GroupWindows[newGroupName].TitleBar:SetVisible(true);
  
  
  
  BuildSwapMenu.GroupWindows[newGroupName].TitleBar.MouseClick = function()
    if(not(BuildSwapMenu.selection == "")) then
      BuildSwapMenu.MenuItems[BuildSwapMenu.selection].SetSelected(false);
      BuildSwapMenu.selection = "";
    end
    BuildSwapMenu.SelectGroup(newGroupName);
  end
  
  BuildSwapMenu.GroupWindows[newGroupName].AddItem = function(newSequenceName)
    local i = BuildSwapMenu.GroupWindows[newGroupName].numItems + 1;
    BuildSwapMenu.GroupWindows[newGroupName].numItems = i;
    BuildSwapMenu.GroupWindows[newGroupName].MenuItemsNames[i] = newSequenceName;
    BuildSwapMenu.GroupWindows[newGroupName]:SetSize(BuildSwapMenu.GroupWindows[newGroupName]:GetWidth(), BuildSwapMenu.GroupWindows[newGroupName]:GetHeight() + 30);
    
    BuildSwapMenu.MenuItems[newSequenceName] = Turbine.UI.Label();
    BuildSwapMenu.MenuItems[newSequenceName].MouseDownOnMe = false;
    BuildSwapMenu.MenuItems[newSequenceName]:SetParent( BuildSwapMenu.GroupWindows[newGroupName] );
    BuildSwapMenu.MenuItems[newSequenceName]:SetText( "    "..newSequenceName );
    BuildSwapMenu.MenuItems[newSequenceName]:SetSize( 340, 30 );
    BuildSwapMenu.MenuItems[newSequenceName]:SetPosition(0, BuildSwapMenu.GroupWindows[newGroupName]:GetHeight() - 30);
    BuildSwapMenu.MenuItems[newSequenceName]:SetOutlineColor( Turbine.UI.Color( 0, 0, 0 ) );
    BuildSwapMenu.MenuItems[newSequenceName]:SetFontStyle( Turbine.UI.FontStyle.Outline );
    BuildSwapMenu.MenuItems[newSequenceName]:SetFont(Turbine.UI.Lotro.Font.Verdana12);
    BuildSwapMenu.MenuItems[newSequenceName]:SetForeColor( Turbine.UI.Color(1,1,1) );
    BuildSwapMenu.MenuItems[newSequenceName]:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
    BuildSwapMenu.MenuItems[newSequenceName]:SetBackground("Turwe\\BuildSwapper\\MenuItemBar.tga");
    BuildSwapMenu.MenuItems[newSequenceName]:SetOpacity(.8);
  
    BuildSwapMenu.MenuItems[newSequenceName].MouseClick = function()
      if(BuildSwapMenu.IsInGroupSelectionMode) then
        BuildSwapMenu.DeselectGroup(BuildSwapMenu.GroupSelection);
        BuildSwapMenu.SetGroupSelectionMode(false);
      end
      
      BuildSwapMenu.MenuItems[newSequenceName].SetSelected(true);
      if ( (not (BuildSwapMenu.selection == "")) and (not (BuildSwapMenu.selection == newSequenceName)) ) then
        BuildSwapMenu.MenuItems[BuildSwapMenu.selection].SetSelected(false);
      else
        BuildSwapMenu.EditButton:SetEnabled(true);
        BuildSwapMenu.DeleteButton:SetEnabled(true);
      end
    
      BuildSwapMenu.selection = newSequenceName;
    
      if(BuildTable[newSequenceName].Shown) then
        BuildSwapMenu.ShowCheckBox:SetChecked(true);
        SequenceWindows[newSequenceName]:SetVisible(true);
      else
        BuildSwapMenu.HideCheckBox:SetChecked(true);
        SequenceWindows[newSequenceName]:SetVisible(false);
      end
    end
  
    BuildSwapMenu.MenuItems[newSequenceName].MouseDown = function()
      BuildSwapMenu.MenuItems[newSequenceName].MouseClick()
      BuildSwapMenu.MenuItems[newSequenceName].MouseDownOnMe = true
      BuildSwapMenu.MenuItems[newSequenceName].x,BuildSwapMenu.MenuItems[newSequenceName].y = BuildSwapMenu.MenuItems[newSequenceName]:GetMousePosition();
      BuildSwapMenu.MenuItems[newSequenceName].screenX, BuildSwapMenu.MenuItems[newSequenceName].screenY = BuildSwapMenu.MenuItems[newSequenceName]:PointToScreen(0,0);
      BuildSwapMenu.MenuItems[newSequenceName]:SetWantsUpdates(true);
      --BuildSwapMenu.MenuItems[newSequenceName]:SetVisible(false);
      --BuildSwapMenu.SpawnDragWindow(newSequenceName, x, y, screenX, screenY)
    end
    
    BuildSwapMenu.MenuItems[newSequenceName].Update = function()
      local deltaX, deltaY = BuildSwapMenu.MenuItems[newSequenceName]:GetMousePosition();
      deltaX = deltaX - BuildSwapMenu.MenuItems[newSequenceName].x;
      deltaY = deltaY - BuildSwapMenu.MenuItems[newSequenceName].y;
      distsq = (deltaX*deltaX) + (deltaY*deltaY)
      
      if(distsq > 4) then
        BuildSwapMenu.MenuItems[newSequenceName]:SetWantsUpdates(false);
        BuildSwapMenu.SpawnDragWindow(newSequenceName, BuildSwapMenu.MenuItems[newSequenceName].x, BuildSwapMenu.MenuItems[newSequenceName].y, BuildSwapMenu.MenuItems[newSequenceName].screenX, BuildSwapMenu.MenuItems[newSequenceName].screenY);
        for k,v in pairs(BuildSwapMenu.GroupWindows) do
          v.SetCustomDragDropMode(true)
        end
        BuildSwapMenu.NewGroupButton:SetVisible(false)
      end
    end
    
    BuildSwapMenu.MenuItems[newSequenceName].MouseUp = function()
      BuildSwapMenu.MenuItems[newSequenceName]:SetWantsUpdates(false);
      if(not (BuildSwapMenu.SpawnWindow == nil)) then
        BuildSwapMenu.DestroyDragWindow()
        for k,v in pairs(BuildSwapMenu.GroupWindows) do
          v.SetCustomDragDropMode(false)
          if(v.IsHighlighted) then
            v.SetHighlighted(false)
            Controller.SetGroup(BuildSwapMenu.selection, k)
            BuildSwapMenu.MenuItems[BuildSwapMenu.selection].SetSelected(true);
          end
        end
        BuildSwapMenu.NewGroupButton:SetVisible(true)
      end
    end
    
    BuildSwapMenu.MenuItems[newSequenceName].SetSelected = function(cond)
      if(cond) then
        BuildSwapMenu.MenuItems[newSequenceName]:SetOutlineColor( Turbine.UI.Color( .05, .3, .05 ) );
        BuildSwapMenu.MenuItems[newSequenceName]:SetBackground("Turwe\\BuildSwapper\\MenuItemBarHighlighted.tga");
        BuildSwapMenu.PulseList[newSequenceName] = SequenceWindows[newSequenceName];
      else
        BuildSwapMenu.MenuItems[newSequenceName]:SetBackground("Turwe\\BuildSwapper\\MenuItemBar.tga");
        BuildSwapMenu.MenuItems[newSequenceName]:SetOutlineColor( Turbine.UI.Color( 0, 0, 0 ) );
        BuildSwapMenu.PulseList[newSequenceName]:SetOpacity(1);
        BuildSwapMenu.PulseList[newSequenceName] = nil;
      end
    end
  end
  
  BuildSwapMenu.GroupWindows[newGroupName].RemoveItem = function(seqName)
    -- If theres nothing in this group, return
    if(BuildSwapMenu.GroupWindows[newGroupName].numItems == 0) then do return end end
    
    local i = 0;
    local sn;
    -- Find the item
    for j = 1, BuildSwapMenu.GroupWindows[newGroupName].numItems do
      -- The menu items after i is found need to be adjusted
      if(i > 0) then
        sn = BuildSwapMenu.GroupWindows[newGroupName].MenuItemsNames[j];
        BuildSwapMenu.MenuItems[sn]:SetPosition(0, BuildSwapMenu.MenuItems[sn]:GetTop() - 30);
        BuildSwapMenu.GroupWindows[newGroupName].MenuItemsNames[(j-1)] = BuildSwapMenu.GroupWindows[newGroupName].MenuItemsNames[j]
      elseif (BuildSwapMenu.GroupWindows[newGroupName].MenuItemsNames[j] == seqName) then
        i = j;
        -- Its been found, so delete the menu item
        BuildSwapMenu.MenuItems[seqName]:SetVisible(false)
        BuildSwapMenu.MenuItems[seqName] = nil;
      end 
    end
    
    -- If it was found, decrement num items, set the last enter in MenuItemsNames to be nil, and decrement the size of the group window
    if(i > 0) then
      BuildSwapMenu.GroupWindows[newGroupName].MenuItemsNames[BuildSwapMenu.GroupWindows[newGroupName].numItems] = nil;
      BuildSwapMenu.GroupWindows[newGroupName].numItems = BuildSwapMenu.GroupWindows[newGroupName].numItems - 1;
      BuildSwapMenu.GroupWindows[newGroupName]:SetSize(BuildSwapMenu.GroupWindows[newGroupName]:GetWidth(), BuildSwapMenu.GroupWindows[newGroupName]:GetHeight() - 30);
    end
  end
  
  BuildSwapMenu.GroupWindows[newGroupName].SetHighlighted = function(cond)
    if(cond) then
      BuildSwapMenu.GroupWindows[newGroupName].IsHighlighted = true
      BuildSwapMenu.GroupWindows[newGroupName].TitleBar:SetBackground("Turwe\\BuildSwapper\\MenuGroupBarHighlighted.tga");
    else
      BuildSwapMenu.GroupWindows[newGroupName].IsHighlighted = false
      --BuildSwapMenu.MenuItems[newSequenceName]:SetOutlineColor( Turbine.UI.Color( 0, 0, 0 ) );
      BuildSwapMenu.GroupWindows[newGroupName].TitleBar:SetBackground("Turwe\\BuildSwapper\\MenuGroupBar.tga");
    end
  end  
  
  BuildSwapMenu.GroupWindows[newGroupName].SetCustomDragDropMode = function(cond)
    if(cond) then
      BuildSwapMenu.GroupWindows[newGroupName]:SetSize(BuildSwapMenu.GroupWindows[newGroupName]:GetWidth(), 30);
    else
      BuildSwapMenu.GroupWindows[newGroupName]:SetSize(BuildSwapMenu.GroupWindows[newGroupName]:GetWidth(), 30*(BuildSwapMenu.GroupWindows[newGroupName].numItems + 1))
    end
  end
end

BuildSwapMenu.SelectGroup = function(GName)
  
  if(BuildSwapMenu.IsInGroupSelectionMode) then
    if(BuildSwapMenu.GroupSelection == GName) then
      do return end
    else
      BuildSwapMenu.DeselectGroup(BuildSwapMenu.GroupSelection)
    end
  else
    BuildSwapMenu.SetGroupSelectionMode(true);
  end
  BuildSwapMenu.GroupWindows[GName].SetHighlighted(true)
  for i, name in pairs(BuildSwapMenu.GroupWindows[GName].MenuItemsNames) do
    BuildSwapMenu.MenuItems[name].SetSelected(true)
  end
  BuildSwapMenu.GroupSelection = GName;
end

BuildSwapMenu.DeselectGroup = function(GName)
  BuildSwapMenu.GroupWindows[GName].SetHighlighted(false)
  for i, name in pairs(BuildSwapMenu.GroupWindows[GName].MenuItemsNames) do
    BuildSwapMenu.MenuItems[name].SetSelected(false)
  end
  BuildSwapMenu.GroupSelection = "";
end

BuildSwapMenu.SetGroupSelectionMode = function(cond)
  if(cond) then
    BuildSwapMenu.ShowAllButton:SetVisible(true);
    BuildSwapMenu.ShowCheckBox:SetVisible(false);
    BuildSwapMenu.HideAllButton:SetVisible(true);
    BuildSwapMenu.HideCheckBox:SetVisible(false);
    BuildSwapMenu.EditButton:SetEnabled(false);
    BuildSwapMenu.DeleteButton:SetEnabled(false);
    BuildSwapMenu.IsInGroupSelectionMode = true;
  else
    BuildSwapMenu.ShowAllButton:SetVisible(false);
    BuildSwapMenu.ShowCheckBox:SetVisible(true);
    BuildSwapMenu.HideAllButton:SetVisible(false);
    BuildSwapMenu.HideCheckBox:SetVisible(true);
    BuildSwapMenu.EditButton:SetEnabled(true);
    BuildSwapMenu.DeleteButton:SetEnabled(true);
    BuildSwapMenu.IsInGroupSelectionMode = false;
  end
end

Controller.AddItemToMenu = function( i )
  if( BuildTable[i].Group == nil ) then
    BuildTable[i].Group = "General"
    if(not (OldDataHandled)) then
      OldDataHandled = true;
      Controller.AddGroupToMenu("PvE");
      Controller.AddGroupToMenu("PvP");
    end
  end
  
  if(BuildSwapMenu.GroupWindows[BuildTable[i].Group] == nil) then
    Controller.AddGroupToMenu(BuildTable[i].Group)
  end
  
  BuildSwapMenu.GroupWindows[BuildTable[i].Group].AddItem(i)
  
  if(not(BuildTable[i].Shown)) then
    BuildSwapMenu.MenuItems[i]:SetForeColor( Turbine.UI.Color(.5, .5, .5) );
  end
  
end

BuildSwapMenu.SpawnDragWindow = function( seqName, xOffset, yOffset, screenX, screenY )
  BuildSwapMenu.SpawnWindow = Turbine.UI.Window()
  BuildSwapMenu.SpawnWindow:SetPosition(screenX, screenY);
  BuildSwapMenu.SpawnWindow:SetSize(340, 30);
  BuildSwapMenu.SpawnWindow:SetOpacity(.6);
  BuildSwapMenu.SpawnWindow:SetZOrder(1000);
  BuildSwapMenu.SpawnWindow:SetWantsUpdates(true)
  BuildSwapMenu.SpawnWindow:SetVisible(true);
  BuildSwapMenu.SpawnWindow:SetWantsKeyEvents(true);
   

  BuildSwapMenu.SpawnWindow.Label = Turbine.UI.Label();
  BuildSwapMenu.SpawnWindow.Label:SetParent( BuildSwapMenu.SpawnWindow);
  BuildSwapMenu.SpawnWindow.Label:SetText( seqName );
  BuildSwapMenu.SpawnWindow.Label:SetSize( 340, 30 );
  BuildSwapMenu.SpawnWindow.Label:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
  BuildSwapMenu.SpawnWindow.Label:SetFontStyle( Turbine.UI.FontStyle.Outline );
  BuildSwapMenu.SpawnWindow.Label:SetFont(Turbine.UI.Lotro.Font.Verdana12);
  BuildSwapMenu.SpawnWindow.Label:SetForeColor( Turbine.UI.Color(1,1,1) );
  BuildSwapMenu.SpawnWindow.Label:SetOutlineColor( Turbine.UI.Color( .05, .3, .05 ) );
  BuildSwapMenu.SpawnWindow.Label:SetBackground("Turwe\\BuildSwapper\\MenuItemBarHighlighted.tga");
  --BuildSwapMenu.SpawnWindow.Label:SetOutlineColor( Turbine.UI.Color( 0, 0, 0 ) );  
  --BuildSwapMenu.SpawnWindow.Label:SetBackground("Turwe\\BuildSwapper\\MenuItemBar.tga");
  BuildSwapMenu.SpawnWindow.Label:SetOpacity(.8);
  
  BuildSwapMenu.SpawnWindow.Update = function()
    local newX, newY = BuildSwapMenu.SpawnWindow.Label:GetMousePosition();
    local curLocX = BuildSwapMenu.SpawnWindow:GetLeft();
    local curLocY = BuildSwapMenu.SpawnWindow:GetTop();
    BuildSwapMenu.SpawnWindow:SetPosition(curLocX + (newX - xOffset), curLocY + (newY - yOffset));
    
    for GName, GWindow in pairs(BuildSwapMenu.GroupWindows) do
      newX, newY = GWindow:GetMousePosition();
      if((newX > 0) and (newY > 0) and (newX <= GWindow:GetWidth()) and (newY <= GWindow:GetHeight())) then
        if(not (GWindow.IsHighlighted)) then
          --Turbine.Shell.WriteLine("Custom MouseEnter on "..GName);
          GWindow.SetHighlighted(true)
        end
      else
        if(GWindow.IsHighlighted) then
          --Turbine.Shell.WriteLine("Custom MouseLeave on "..GName);
          GWindow.SetHighlighted(false)
        end
      end
    end
  end
end

BuildSwapMenu.DestroyDragWindow = function()
  if(not(BuildSwapMenu.SpawnWindow == nil)) then
    BuildSwapMenu.SpawnWindow:SetVisible(false);
    BuildSwapMenu.SpawnWindow:SetWantsUpdates(false);
    BuildSwapMenu.SpawnWindow = nil
  end
end








Controller.SetGroup = function(seqName, groupName)
  local oldGroup = BuildTable[seqName].Group;
  BuildSwapMenu.GroupWindows[oldGroup].RemoveItem(seqName)
  BuildTable[seqName].Group = groupName;
  Controller.AddItemToMenu(seqName);
end

Controller.Initialize = function()
  Controller.AddGroupToMenu("General");
  for name, value in pairs(BuildTable) do
    Controller.AddItemToMenu(tostring(name));
    Controller.GenerateSequenceWindow(tostring(name));
  end
  
  for name in pairs(GroupList) do
    if BuildSwapMenu.GroupWindows[name] == nil then
      Controller.AddGroupToMenu(name)
    end
  end
  
  local temp = Turbine.PluginData.Load(Turbine.DataScope.Character, "ExtraSlots");
  if(temp == nil) then do return end end
  for unnecessaryVar, data in pairs(temp) do
    local i = Controller.CreateNewQuickslot();
    QuickslotsTable[i].Quickslot:SetShortcut(Turbine.UI.Lotro.Shortcut(data.type, data.data));
    QuickslotsTable[i]:SetPosition(data.xPos, data.yPos);
    QuickslotsTable[i].MovePanel:SetVisible(false);
  end
end

Controller.CollectData = function()
  local i = SequenceBuilder.NameBox:GetText();
  
  -- Grab Shown
  BuildTable[i].Shown = false
  if( SequenceBuilder.ShowBox:IsChecked() ) then
    BuildTable[i].Shown = true
  end
  
  -- Grab Reset Policy
  BuildTable[i].ResetPolicy = ResetPolicy.Timeout
  if( SequenceBuilder.ContinuousBox:IsChecked() ) then
    BuildTable[i].ResetPolicy = ResetPolicy.Continuous
  elseif ( SequenceBuilder.HideBox:IsChecked() ) then
    BuildTable[i].ResetPolicy = ResetPolicy.Hide
  end
  
  -- Grab X, Y coords of quickslot
  BuildTable[i].XPos = SequenceBuilder.QuickSlotPlacer:GetLeft()-2;
  BuildTable[i].YPos = SequenceBuilder.QuickSlotPlacer:GetTop()-2;
  
  -- Grab Quickslot Data  
  for j = 1,30 do
    local temp = SequenceBuilder.QuickSlot[j]:GetShortcut();
    BuildTable[i].QuickSlotType[j] = temp:GetType()
    BuildTable[i].QuickSlotData[j] = temp:GetData()
  end
  
  -- Assign to General
  BuildTable[i].Group = "General"
end

Controller.ProcessSave = function()
  local i = SequenceBuilder.NameBox:GetText();
   -- ************* Check Validity and Conditions of the Name **********************
  if(i == "") then
    SequenceBuilder.ErrorLabel:SetText("You must give this build sequence a name!")
    do return end
  end
  
  local isNewBuild = false;
  if SequenceBuilder.SequenceName == "" then
    isNewBuild = true
  end
  
  local hasNewName = true
  if SequenceBuilder.SequenceName == i then
    hasNewName = false;
  end
  
  if( hasNewName and (not (BuildTable[i] == nil)) ) then
    SequenceBuilder.ErrorLabel:SetText("A sequence with this name already exists!");
    do return end
  end
  -- *********************** End Validity/Conditions Check *************************
  
    -- If this is an edit window and they changed the name, delete the old table and sequence window
  if ((not isNewBuild) and hasNewName) then
    Controller.Delete(SequenceBuilder.SequenceName);
  end
  
  if hasNewName then
    BuildTable[i] = {}
    BuildTable[i].QuickSlotType = {}
    BuildTable[i].QuickSlotData = {}
  end

  Controller.CollectData();
  
  if hasNewName then
    Controller.AddItemToMenu(i);
    Controller.GenerateSequenceWindow(i);
    BuildSwapMenu.MenuItems[i].MouseClick();
  else
    Controller.UpdateSequenceWindow(i);
  end
  SequenceBuilder:Close();
  
  Turbine.PluginData.Save(Turbine.DataScope.Character, "BuildSwapper", BuildTable);
end

-- Every time a bank item gets removed, refresh all the quickslot sequence windows
Controller.BankItemRemoved = function()
  for name in pairs(BuildTable) do
    Controller.UpdateSequenceWindow(name); 
  end
end

-- *******************************************************************************************************************
--                            End Controller Functions
-- *******************************************************************************************************************


-- *******************************************************************************************************************
--                            Build Swap Menu Functions
-- *******************************************************************************************************************

BuildSwapMenu.NewButton.MouseClick = function()
  if not (BuildSwapMenu.selection == "") then
      BuildSwapMenu.MenuItems[BuildSwapMenu.selection].SetSelected(false)
      BuildSwapMenu.selection = ""
  end
  BuildSwapMenu.HideCheckBox:SetChecked(false);
  BuildSwapMenu.ShowCheckBox:SetChecked(false);
  BuildSwapMenu.HideCheckBox:SetEnabled(false);
  BuildSwapMenu.ShowCheckBox:SetEnabled(false);
  Controller.DisplayNewSequenceBuilderWindow();
  BuildSwapMenu:Close()
end

BuildSwapMenu.EditButton.MouseClick = function()
  Controller.DisplaySequenceBuilderWindow(BuildSwapMenu.selection);
  BuildSwapMenu:Close()
end

BuildSwapMenu.DeleteButton.MouseClick = function()
  Controller.Delete( BuildSwapMenu.selection );
end

BuildSwapMenu.HideCheckBox.CheckedChanged = function()
  if( BuildSwapMenu.HideCheckBox:IsChecked() ) then
    BuildSwapMenu.HideCheckBox:SetEnabled(false);
    BuildSwapMenu.ShowCheckBox:SetChecked(false);
    BuildSwapMenu.ShowCheckBox:SetEnabled(true);
    Controller.Hide(BuildSwapMenu.selection);
  end
end

BuildSwapMenu.ShowCheckBox.CheckedChanged = function()
  if( BuildSwapMenu.ShowCheckBox:IsChecked() ) then
    BuildSwapMenu.HideCheckBox:SetEnabled(true);
    BuildSwapMenu.ShowCheckBox:SetEnabled(false);
    BuildSwapMenu.HideCheckBox:SetChecked(false);
    Controller.Show(BuildSwapMenu.selection);
  end
end

BuildSwapMenu.ShowAllButton.MouseClick = function()
  for k,v in pairs(BuildSwapMenu.GroupWindows[BuildSwapMenu.GroupSelection].MenuItemsNames) do
    Controller.Show(v);
  end
end

BuildSwapMenu.HideAllButton.MouseClick = function()
  for k,v in pairs(BuildSwapMenu.GroupWindows[BuildSwapMenu.GroupSelection].MenuItemsNames) do
    Controller.Hide(v);
  end
end

BuildSwapMenu.NewGroupButton.MouseClick = function()
  local w = 400;
  local h = 110;
  if(BuildSwapMenu.NewGroupDialogBox == nil) then
    BuildSwapMenu.NewGroupDialogBox = Turbine.UI.Lotro.Window()
    BuildSwapMenu.NewGroupDialogBox:SetSize(w, h)
    BuildSwapMenu.NewGroupDialogBox:SetPosition((BuildSwapMenu:GetWidth()/2) - (w/2) + BuildSwapMenu:GetLeft(), (BuildSwapMenu:GetHeight()/2) - (h/2) + BuildSwapMenu:GetTop());
    BuildSwapMenu.NewGroupDialogBox:SetText("Add New Group");
    BuildSwapMenu.NewGroupDialogBox:SetZOrder(BuildSwapMenu:GetZOrder() + 1);
    BuildSwapMenu.NewGroupDialogBox:SetVisible(true);
    
    BuildSwapMenu.NewGroupDialogBox.InstLabel = Turbine.UI.Label()
    BuildSwapMenu.NewGroupDialogBox.InstLabel:SetParent(BuildSwapMenu.NewGroupDialogBox);
    BuildSwapMenu.NewGroupDialogBox.InstLabel:SetText("Please enter a name for the new group:")
    BuildSwapMenu.NewGroupDialogBox.InstLabel:SetSize(w - 40, 25)
    BuildSwapMenu.NewGroupDialogBox.InstLabel:SetPosition(30, 20)
    BuildSwapMenu.NewGroupDialogBox.InstLabel:SetTextAlignment(Turbine.UI.ContentAlignment.BottomLeft)
    
    BuildSwapMenu.NewGroupDialogBox.NameBox = Turbine.UI.TextBox()
    BuildSwapMenu.NewGroupDialogBox.NameBox:SetParent(BuildSwapMenu.NewGroupDialogBox);
    BuildSwapMenu.NewGroupDialogBox.NameBox:SetSize(w - 20, 25)
    BuildSwapMenu.NewGroupDialogBox.NameBox:SetPosition(10, 50)
    BuildSwapMenu.NewGroupDialogBox.NameBox:SetBackColor(Turbine.UI.Color(.01, .01, .11))
    BuildSwapMenu.NewGroupDialogBox.NameBox:SetTextAlignment(Turbine.UI.ContentAlignment.BottomCenter)
    BuildSwapMenu.NewGroupDialogBox.NameBox:SetFont(Turbine.UI.Lotro.Font.Verdana16);
    BuildSwapMenu.NewGroupDialogBox.NameBox:SetMultiline(false)
    
    BuildSwapMenu.NewGroupDialogBox.AddButton = Turbine.UI.Lotro.Button()
    BuildSwapMenu.NewGroupDialogBox.AddButton:SetParent(BuildSwapMenu.NewGroupDialogBox);
    BuildSwapMenu.NewGroupDialogBox.AddButton:SetSize(120, 25)
    BuildSwapMenu.NewGroupDialogBox.AddButton:SetPosition((w/2) - 60, 80)
    BuildSwapMenu.NewGroupDialogBox.AddButton:SetText("Add Group")
    
    BuildSwapMenu.NewGroupDialogBox.AddButton.MouseClick = function()
      local newGName = BuildSwapMenu.NewGroupDialogBox.NameBox:GetText()
      if(BuildSwapMenu.GroupWindows[newGName] == nil) then
        BuildSwapMenu.NewGroupDialogBox:SetVisible(false)
        BuildSwapMenu.NewGroupDialogBox = nil
        Controller.AddGroupToMenu(newGName);
      else
        BuildSwapMenu.NewGroupDialogBox.InstLabel:SetText("A group already exists with that name!")
      end
    end   
    
  else
    BuildSwapMenu.NewGroupDialogBox:SetPosition((BuildSwapMenu:GetWidth()/2) - (w/2) + BuildSwapMenu:GetLeft(), (BuildSwapMenu:GetHeight()/2) - (h/2) + BuildSwapMenu:GetTop());
    BuildSwapMenu.NewGroupDialogBox:SetZOrder(BuildSwapMenu:GetZOrder() + 1);
    BuildSwapMenu.NewGroupDialogBox.NameBox:SetText("");
    BuildSwapMenu.NewGroupDialogBox.InstLabel:SetText("Please enter a name for the new group:")
    BuildSwapMenu.NewGroupDialogBox:SetVisible(true);
  end
  
end

BuildSwapMenu.SpawnQuickslotButton.MouseClick = function()
  Controller.CreateNewQuickslot()
end

BuildSwapMenu.KeyDown = function(sender, args)
  if((args["Control"]) and (args["Action"] == 268435579)) then -- ctrl+\
    Controller.ToggleMoveMode();
  end
end

-- *******************************************************************************************************************
--              Singleton Quickslots Functionality
-- *******************************************************************************************************************


Controller.CreateNewQuickslot = function()
  local xPos = BuildSwapMenu:GetLeft() + (BuildSwapMenu:GetWidth()/2) - 18;
  local yPos = BuildSwapMenu:GetTop() + BuildSwapMenu:GetHeight() + 20;
  
  local i = 1;
  -- Find an empty spot in the quickslots table
  while (not(QuickslotsTable[i] == nil)) do
    i = i + 1;
  end
  
  QuickslotsTable[i] = Turbine.UI.Window();
  QuickslotsTable[i]:SetPosition(xPos, yPos);
  QuickslotsTable[i]:SetSize(35,35);
  QuickslotsTable[i]:SetVisible(true);
  
  QuickslotsTable[i].Quickslot = Turbine.UI.Lotro.Quickslot()
  QuickslotsTable[i].Quickslot:SetParent(QuickslotsTable[i])
  
  QuickslotsTable[i].MovePanel = Turbine.UI.Control()
  QuickslotsTable[i].MovePanel:SetParent(QuickslotsTable[i]);
  QuickslotsTable[i].MovePanel:SetSize(35,35);
  QuickslotsTable[i].MovePanel:SetPosition(0,0);
  QuickslotsTable[i].MovePanel:SetAllowDrop(true);
  QuickslotsTable[i].MovePanel:SetBackground("Turwe\\BuildSwapper\\MoveOverlay.tga");
  QuickslotsTable[i].MovePanel:SetStretchMode(2);
  QuickslotsTable[i].MovePanel:SetOpacity(.5);
  if(Controller.UIEditMode) then
    QuickslotsTable[i].MovePanel:SetVisible(true);
  else
    QuickslotsTable[i].MovePanel:SetVisible(false);
  end

  
  QuickslotsTable[i].MovePanel.MouseDown = function()
    QuickslotsTable[i].MouseIsDown = true;
    QuickslotsTable[i].xOffset, QuickslotsTable[i].yOffset = QuickslotsTable[i]:GetMousePosition();
  end
  
  QuickslotsTable[i].MovePanel.MouseUp = function()
    QuickslotsTable[i].MouseIsDown = false;
  end
  
  QuickslotsTable[i].MovePanel.MouseMove = function()
    if QuickslotsTable[i].MouseIsDown then
      local curX, curY = QuickslotsTable[i]:GetPosition();
      local newXOffset, newYOffset = QuickslotsTable[i]:GetMousePosition();
      QuickslotsTable[i]:SetPosition(curX + newXOffset - QuickslotsTable[i].xOffset, curY + newYOffset - QuickslotsTable[i].yOffset);
    end
  end
  
  QuickslotsTable[i].MovePanel.MouseClick = function(sender, args)
    if(args["Button"] == 2) then
      Controller.DeleteQuickslot(i);
    end
  end
  
  QuickslotsTable[i].MovePanel.DragDrop = function(sender, args)
    if(args.DragDropInfo == nil) then
      do return end
    end
    
    if(not (args.DragDropInfo:GetShortcut() == nil)) then
      QuickslotsTable[i].Quickslot:SetShortcut(args.DragDropInfo:GetShortcut());
    end
  end
  
  return i
end

Controller.DeleteQuickslot = function( i )
  QuickslotsTable[i]:SetVisible(false);
  QuickslotsTable[i] = nil;
  BuildSwapMenu.PulseList[i] = nil
end

Controller.BringToFront = function()
  for i, QuickslotWindow in pairs(QuickslotsTable) do
    QuickslotWindow:SetZOrder(100);
  end
end

Controller.SendToBack = function()
  for i, QuickslotWindow in pairs(QuickslotsTable) do
    QuickslotWindow:SetZOrder(-100);
  end
end

Controller.ToggleMoveMode = function()
  if(Controller.UIEditMode) then
    Controller.UIEditMode = false;
    for i, data in pairs(QuickslotsTable) do
      data.MovePanel:SetVisible(false);
    end
    for i, data in pairs(SequenceWindows) do
      data.MovePanel:SetVisible(false);
    end
  else
    Controller.UIEditMode = true;
    for i, data in pairs(QuickslotsTable) do
      data.MovePanel:SetVisible(true);
    end
    for i, data in pairs(SequenceWindows) do
      data.MovePanel:SetVisible(true);
    end
  end
end
-- *******************************************************************************************************************
--              Shell Cmd
-- *******************************************************************************************************************


Controller.ShellCommand = Turbine.ShellCommand();
Turbine.Shell.AddCommand("BuildSwapper", Controller.ShellCommand);


Controller.ShellCommand.Execute = function(sender, cmd, args)

  local i = 1;
  local token = {}
  for word in string.gmatch(args, "%a+") do
    token[i] = word;
    i = i + 1;
  end
  
  if(token[1] == nil) then
    Turbine.Shell.WriteLine("Usage:");
	  Turbine.Shell.WriteLine("/buildswapper toggle : this will show or hide the build swapper main menu.");
	  Turbine.Shell.WriteLine("/buildswapper show [build name] : this will show a quickslot sequence that has been set to hidden");
	  Turbine.Shell.WriteLine("/buildswapper unequip [slotname] : this will unequip the item in the specified slotname");
    Turbine.Shell.WriteLine("/buildswapper bringtofront : this will bring all buildswapper quickslots in front of other UI objects");
	  Turbine.Shell.WriteLine("/buildswapper sendtoback : this will send all buildswapper quickslots behind other UI objects");
    do return end
  end
  
  local command = string.lower(token[1]);
	if (command == "show") then
    local buildName = string.sub(args, command:len()+2)
    --local buildName = 
    Turbine.Shell.WriteLine("Attempting to show quickslot sequence: "..buildName);
    if(BuildTable[(buildName)] == nil) then
      Turbine.Shell.WriteLine("Quickslot sequence: "..buildName.." not found.");
    else
      Controller.Show(buildName);
    end
  elseif command == "toggle" then
    if(BuildSwapMenu:IsVisible()) then
      BuildSwapMenu:Close();
    else
      if(SequenceBuilder:IsVisible()) then
        Turbine.Shell.WriteLine("Cannot display the main menu until the sequence builder is closed.");
      else
        BuildSwapMenu.Open();
      end
    end
  elseif command == "unequip" then
    Controller.UnequipCommand(string.sub(args, (command:len()+2)));
  elseif command == "bringtofront" then
    Controller.BringToFront()
  elseif command == "sendtoback" then
    Controller.SendToBack()
	else
	  Turbine.Shell.WriteLine("Usage:");
	  Turbine.Shell.WriteLine("/buildswapper toggle : this will show or hide the build swapper main menu.");
	  Turbine.Shell.WriteLine("/buildswapper show [build name] : this will show a quickslot sequence that has been set to hidden");
	  Turbine.Shell.WriteLine("/buildswapper unequip [slotname] : this will unequip the item in the specified slotname");
	  Turbine.Shell.WriteLine("/buildswapper bringtofront : this will bring all buildswapper quickslots in front of other UI objects");
	  Turbine.Shell.WriteLine("/buildswapper sendtoback : this will send all buildswapper quickslots behind other UI objects");
	end
end

Controller.UnequipCommand = function(args)  
	local pos1=string.find(args," ",0,true);
	local slot;
	if pos1~=nil and pos1>0 then
		slot=string.lower(string.sub(args,1,pos1-1));
	else
		slot=string.lower(args);
	end

	local slotNumber = 0;
	if (slot=="back") then
		slotNumber=Turbine.Gameplay.Equipment.Back;
	elseif (slot=="boots") then
		slotNumber=Turbine.Gameplay.Equipment.Boots;
	elseif (slot=="bracelet1") then
		slotNumber=Turbine.Gameplay.Equipment.Bracelet1;
	elseif (slot=="bracelet2") then
		slotNumber=Turbine.Gameplay.Equipment.Bracelet2;
	elseif (slot=="bracelets") then
    slotNumber = Turbine.Gameplay.Equipment.Bracelet1;
    Controller.UnequipCommand("Bracelet2");	
	elseif (slot=="chest") then
		slotNumber=Turbine.Gameplay.Equipment.Chest;
	elseif (slot=="class") then
		slotNumber=Turbine.Gameplay.Equipment.Class;
	elseif (slot=="crafttool") then
		slotNumber=Turbine.Gameplay.Equipment.CraftTool;
	elseif (slot=="earring1") then
		slotNumber=Turbine.Gameplay.Equipment.Earring1;
	elseif (slot=="earring2") then
		slotNumber=Turbine.Gameplay.Equipment.Earring2;
	elseif (slot=="earrings") then
    slotNumber = Turbine.Gameplay.Equipment.Earring1;
    Controller.UnequipCommand("Earring2");	
	elseif (slot=="gloves") then
		slotNumber=Turbine.Gameplay.Equipment.Gloves;
	elseif (slot=="head") then
		slotNumber=Turbine.Gameplay.Equipment.Head;
	elseif (slot=="instrument") then
		slotNumber=Turbine.Gameplay.Equipment.Instrument;
	elseif (slot=="legs") then
		slotNumber=Turbine.Gameplay.Equipment.Legs;
	elseif (slot=="necklace") then
		slotNumber=Turbine.Gameplay.Equipment.Necklace;
	elseif (slot=="pocket") then
		slotNumber=Turbine.Gameplay.Equipment.Pocket;
	elseif (slot=="primaryweapon") then
		slotNumber=Turbine.Gameplay.Equipment.PrimaryWeapon;
	elseif (slot=="rangedweapon") then
		slotNumber=Turbine.Gameplay.Equipment.RangedWeapon;
  elseif (slot=="weapons") then
    slotNumber = Turbine.Gameplay.Equipment.PrimaryWeapon;
    Controller.UnequipCommand("SecondaryWeapon");
	elseif (slot=="ring1") then
		slotNumber=Turbine.Gameplay.Equipment.Ring1;
	elseif (slot=="ring2") then
		slotNumber=Turbine.Gameplay.Equipment.Ring2;
  elseif (slot=="rings") then
    slotNumber = Turbine.Gameplay.Equipment.Ring1;
    Controller.UnequipCommand("ring2");
	elseif (slot=="secondaryweapon") then
		slotNumber=Turbine.Gameplay.Equipment.SecondaryWeapon;
	elseif (slot=="shield") then
		slotNumber=Turbine.Gameplay.Equipment.Shield;
	elseif (slot=="shoulder") then
		slotNumber=Turbine.Gameplay.Equipment.Shoulder;
	else
		Turbine.Shell.WriteLine("usage:");
		Turbine.Shell.WriteLine("/Buildswapper unequip [slotname] : Unequipps the item in the slotname specified. The valid slot names are:");
		Turbine.Shell.WriteLine("  Back, Boots, Bracelet1, Bracelet2, Chest, Class, CraftTool, Earring1, Earring2, Gloves, Head, Instrument, Legs, Necklace, Pocket, PrimaryWeapon, RangedWeapon, Ring1, Ring2, SecondaryWeapon, Shield, Shoulder");
		Turbine.Shell.WriteLine("  Also, Rings, Bracelets, Earrings, or Weapons can be passed to unequip both items of that type.")
	end
	if slotNumber~=0 then
		-- find an empty bag slot
		local bagSlot=-1;
		local index=0;
		local lp=Turbine.Gameplay.LocalPlayer:GetInstance();
		local bags=lp:GetBackpack();
		local equippedItems=lp:GetEquipment();
		local item=equippedItems:GetItem(slotNumber);

		for index=1, bags:GetSize() do
			if bags:GetItem(index)==nil then
				bagSlot=index;
				break;
			end
		end
		if bagSlot==-1 then
			Turbine.Shell.WriteLine("Inventory full! Item not unequipped.");
		else
			if item~=nil then
				bags:PerformItemDrop(item, bagSlot, false);
			end
		end
	end
end

BankWatcher = {};
BankWatcher.OnBankItemRemoved = function()
  --Turbine.Shell.WriteLine("Bank Item Removed.");
  Controller.BankItemRemoved();
end

AddCallback( (Turbine.Gameplay.LocalPlayer:GetInstance():GetVault()),"ItemRemoved", BankWatcher.OnBankItemRemoved);

Controller.Initialize();
BuildSwapMenu.Open()
BuildSwapMenu:SetWantsUpdates(true);


